
Type TEditorGuiMain
	Field Window:NUI_Window
	Field LoadButton:NUI_Button
	Field SaveButton:NUI_Button
	
	Field Tabber:NUI_Tabber
	
	Field WorldPage:NUI_TabPage
	Field LevelsPage:NUI_TabPage
	Field OtherPage:NUI_TabPage
	
	Field WorldName:NUI_TextBox
	Field WorldID:NUI_TextBox
	Field WorldLevelStart:NUI_TextBox
	
	Field WorldAutoSaveEnable:NUI_CheckBox
	Field WorldAutoSaveTime:NUI_TextBox
	
	Field LevelsTree:NUI_TreeView
	Field LevelName:NUI_TextBox
	
	Field CurrentLevel:NUI_Label
	
	Field CreateLevel:NUI_Button
	Field DeleteLevel:NUI_Button
	Field RenameLevel:NUI_Button
	Field SelectLevel:NUI_Button

	Function Create:TEditorGuiMain()
		Local gm:TEditorGuiMain = New TEditorGuiMain
		gm.Init()
		Return gm
	End Function

	Function OnClose(sender:NUI_Window,cancel:Int Var)
		cancel = True
		sender.Minimize()
	End Function
	
	Method MouseOnWindow%()
		Local mx% = ((MouseX() < (Window._area.X - Window._padding.LeftSide)) Or (MouseX() > (Window._area.X + Window._area.Width - Window._padding.RightSide)))
		Local my% = ((MouseY() < (Window._area.Y + Window._padding.TopSide)) Or (MouseY() > (Window._area.Y + Window._area.Height + Window._padding.BottomSide)))
		If mx Or my Then
			Return 0
		Else
			Return 1
		End If
	End Method
	
	Function OnLoadWorldPress(sender:NUI_Control)
		Local file_name$ = "Media/Worlds/"+Editor.GuiMain.WorldName.GetText()+".jwd"
		
		Local file:TStream = ReadFile(file_name)
		If file = Null Then Return
		file.Close()
		file = Null
		
		
		For Local world:TWorld = EachIn WorldManager.Worlds
			world.Close()
			world.Free()
		Next
		WorldManager.Worlds.Clear()
		'WorldManager.CurrentWorld.Close()
		'WorldManager.CurrentWorld.Free()
		'WorldManager.Worlds.Remove(WorldManager.CurrentWorld)
		WorldManager.CurrentWorld = Null
		
		For Local cr:TCreation = EachIn Creations
			cr.Free()
		Next
		Creations.Clear()
		
		Local curworld:TWorldLoader = WorldManager.LoadWorld(file_name)
		
		WorldManager.ChangeWorld(curworld.WorldNum,0,0)
		
		If Editor.GuiObjects.SelectedObjects Then
			Editor.GuiObjects.SelectedObjects.Objs.Clear()
		End If
		Editor.GuiObjects.CreateObjectMode = 0
		Editor.GuiObjects.RotateEnable = 0
		Editor.GuiObjects.SelectionMode = 0
		Editor.GuiObjects.MovingMode = 0
		Editor.GuiObjects.RotatingMode = 0
		
		Editor.GuiMain.WorldID.SetText(WorldManager.CurrentWorld.WorldNum)
		Editor.GuiMain.WorldLevelStart.SetText(WorldManager.CurrentWorld.StartLevel)
		
		For Local ch:NUI_TreeViewNode = EachIn Editor.GuiMain.LevelsTree._children
			ch.Dispose()
		Next
		Editor.GuiMain.LevelsTree._children.Clear()
		For Local level:TLevel = EachIn WorldManager.CurrentWorld.Levs
			NUI_TreeViewNode.Create("Level "+level.LevelNum,NGui,Editor.GuiMain.LevelsTree)
		Next
		
		Editor.GuiMain.CurrentLevel.SetText("Current Level : Level "+WorldManager.CurrentWorld.StartLevel)
		
		Editor.GuiObjects.RecreateLevelTree()
	End Function

	Function OnSaveWorldPress(sender:NUI_Control)
		Local file_name$ = "Media/Worlds/"+Editor.GuiMain.WorldName.GetText()+".jwd"
		
		WorldManager.CurrentWorld.WorldNum = Editor.GuiMain.WorldID.GetText().ToInt()
		WorldManager.CurrentWorld.StartLevel = Editor.GuiMain.WorldLevelStart.GetText().ToInt()
		TWorldLoader(WorldManager.CurrentWorld).SaveWorld(file_name)
	End Function

	Method Init()
		Window = NUI_Window.Create("jEditor Main", 0, 0, 500, 400, NGui, Null)
		Window.OnClose = TEditorGuiMain.OnClose
		Window.SetBorderMode(NUI_WINDOW_BORDER_NORMAL_SIZABLE)
		
		'Window.Minimize()
		Window.SetMaximizeShown(0)
		
		Tabber = NUI_Tabber.Create(5,5,480,350,NGui,Window)
		
		WorldPage = NUI_TabPage.Create("World",NGui,Tabber)
		
			LoadButton = NUI_Button.Create("Load World", 30, 40, 100, 30, NGui, WorldPage)
			LoadButton.OnPress = TEditorGuiMain.OnLoadWorldPress
			SaveButton = NUI_Button.Create("Save World", 30, 80, 100, 30, NGui, WorldPage)
			SaveButton.OnPress = TEditorGuiMain.OnSaveWorldPress
			
			WorldName = NUI_TextBox.Create(150,40,100,30,NGui,WorldPage)
				NUI_ToolTip.Create("World File Name",NGui,WorldName)

			WorldID = NUI_TextBox.Create(150,80,100,30,NGui,WorldPage)
				NUI_ToolTip.Create("World ID",NGui,WorldID)

			WorldLevelStart = NUI_TextBox.Create(150,120,100,30,NGui,WorldPage)
				NUI_ToolTip.Create("World Level Start",NGui,WorldLevelStart)
				
			WorldAutoSaveEnable = NUI_CheckBox.Create("AutoSave",30,160,100,20,NGui,WorldPage)
				WorldAutoSaveEnable.SetChecked(1)
				NUI_ToolTip.Create("World AutoSave Enable\Disable",NGui,WorldAutoSaveEnable)

			WorldAutoSaveTime = NUI_TextBox.Create(30,185,100,25,NGui,WorldPage)
				WorldAutoSaveTime.SetText("180")
				NUI_ToolTip.Create("World AutoSave Time in seconds",NGui,WorldAutoSaveTime)
			
		LevelsPage = NUI_TabPage.Create("Levels",NGui,Tabber)
		
			LevelsTree = NUI_TreeView.Create(10,10,200,250,NGui,LevelsPage)
			LevelsTree.OnSelectionChanged = TEditorGuiMain.OnTreeSelectLevel

			NUI_TreeViewNode.Create("Level 1",NGui,LevelsTree)
			
			LevelName = NUI_TextBox.Create(220,10,100,30,NGui,LevelsPage)
			LevelName.SetText("Level ID")

			CurrentLevel = NUI_Label.Create("Current Level : Level 1",10,270,130,30,NGui,LevelsPage)
			CurrentLevel.SetBorderMode(1)

			CreateLevel = NUI_Button.Create("Create Level", 220, 50, 100, 30, NGui, LevelsPage)
			CreateLevel.OnPress = TEditorGuiMain.OnCreateLevelPress
			
			DeleteLevel = NUI_Button.Create("Delete Level", 220, 90, 100, 30, NGui, LevelsPage)
			DeleteLevel.OnPress = TEditorGuiMain.OnDeleteLevelPress

			RenameLevel = NUI_Button.Create("Rename Level", 220, 130, 100, 30, NGui, LevelsPage)
			RenameLevel.OnPress = TEditorGuiMain.OnRenameLevelPress

			SelectLevel = NUI_Button.Create("Select Level", 220, 235, 100, 30, NGui, LevelsPage)
			SelectLevel.OnPress = TEditorGuiMain.OnSelectLevelPress

		OtherPage = NUI_TabPage.Create("Other",NGui,Tabber)
	End Method
	
	Function OnTreeSelectLevel(sender:NUI_TreeView, node:NUI_TreeViewNode)
		Local lid% = node.GetText().Replace("Level ","").ToInt()
		
		Local level:TLevel = WorldManager.CurrentWorld.FindLevel(lid)
		
		Local gm:TEditorGuiMain = Editor.GuiMain
		If level <> Null Then
			gm.LevelName.SetText(level.LevelNum)
		Else
			gm.LevelName.SetText(lid)
		End If
	End Function
	
	Function OnCreateLevelPress(sender:NUI_Control)
		Local world:TWorldLoader = TWorldLoader(WorldManager.CurrentWorld)
		Local gm:TEditorGuiMain = Editor.GuiMain
		Local level:TLevel = TLevelWorldLoader.Create(Null)
		
		Local id% = 0
		
		For Local lev:TLevel = EachIn world.Levs
			If lev.LevelNum > id Then id = lev.LevelNum
		Next

		level.LevelNum = id + 1
		
		world.Levs.AddLast(level)

		level.WorldNum = world.WorldNum
		level.Init()
		level.LevelInit = 1
		
		NUI_TreeViewNode.Create("Level "+level.LevelNum,NGui,gm.LevelsTree)
	End Function
	
	Function OnDeleteLevelPress(sender:NUI_Control)
	End Function
	
	Function OnRenameLevelPress(sender:NUI_Control)
		Local world:TWorldLoader = TWorldLoader(WorldManager.CurrentWorld)
		Local gm:TEditorGuiMain = Editor.GuiMain

		Local new_id% = gm.LevelName.GetText().ToInt()
		
		For Local lev:TLevel = EachIn world.Levs
			If lev.LevelNum = new_id Then Return
		Next
		
		Local lvl_old% = gm.LevelsTree.GetSelectedNode().GetText().Replace("Level ","").ToInt()
		
		Local level:TLevel = WorldManager.CurrentWorld.FindLevel(lvl_old)
		
		level.LevelNum = new_id
		
		gm.LevelsTree.GetSelectedNode().SetText("Level "+new_id)
	End Function
	
	Function OnSelectLevelPress(sender:NUI_Control)
		Local world:TWorldLoader = TWorldLoader(WorldManager.CurrentWorld)
		Local gm:TEditorGuiMain = Editor.GuiMain
		Local level_id% = gm.LevelsTree.GetSelectedNode().GetText().Replace("Level ","").ToInt()
		
		world.ChangeLevel(level_id,0)
		
		gm.CurrentLevel.SetText("Current Level : Level "+level_id)
		
		Editor.GuiObjects.RecreateLevelTree()
	End Function
	
	Field LastSavedTime#
	
	Method Update()
		If WorldAutoSaveEnable.GetChecked() = 1 Then
			If WorldAutoSaveTime.GetText() And (jMilliSecs() - LastSavedTime) > (WorldAutoSaveTime.GetText().ToFloat()*1000) Then
				LastSavedTime = jMilliSecs()
				If Not ReadDir("Media/Worlds/EditorAutoSave") Then CreateDir("Media/Worlds/EditorAutoSave")
				Local file_name$ = "Media/Worlds/EditorAutoSave/AutoSave-"
				file_name:+Replace(CurrentDate()," ","-")
				file_name:+"-"
				file_name:+Replace(CurrentTime(),":","-")
				file_name:+".jwd"
				
				WorldManager.CurrentWorld.WorldNum = Editor.GuiMain.WorldID.GetText().ToInt()
				WorldManager.CurrentWorld.StartLevel = Editor.GuiMain.WorldLevelStart.GetText().ToInt()
				TWorldLoader(WorldManager.CurrentWorld).SaveWorld(file_name)
			End If
		End If
	End Method
	
	Method Free()
		
	End Method
	
	
	
End Type

