
Type TBonusLifeDouble Extends TBonus

	Field BonusObject1:TCreationObject
	Field BonusObject2:TCreationObject

	Method Add(obj:TCreationObject)
	End Method
	
	Method Update()
		If Cr <> Null Then
			If (Not Cr.CreationObjects.Contains(BonusObject1)) Or (Not Cr.CreationObjects.Contains(BonusObject2)) Then
				Player.BonusManager.RemovePlayerBonus(Self,0)
				Return
			End If
			'if BonusObject1
			If BonusObject1.Hp = 0 Or BonusObject2.Hp = 0 Then Player.BonusManager.RemovePlayerBonus(Self,0)
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method Free()
		BonusObject1 = Null
		BonusObject2 = Null
		'Deactivate()
		BonusImage = Null
	End Method
	
	Method Serealize()
		If Cr = Null Then Return
	
		Local objgr%,objgrn%
		
		If BonusObject1 <> Null Then
			objgrn = BonusObject1.CreationInGroupNum
			objgr = BonusObject1.CreationGroupId
		End If
		
		SerInt(objgr)
		SerInt(objgrn)
		
		BonusObject1 = Cr.gcgo(objgrn,objgr)

		If BonusObject2 <> Null Then
			objgrn = BonusObject2.CreationInGroupNum
			objgr = BonusObject2.CreationGroupId
		End If
		
		SerInt(objgr)
		SerInt(objgrn)
		
		BonusObject2 = Cr.gcgo(objgrn,objgr)
	End Method
	
	Method Activate()
		If Cr = Null Then Return
		If Activated = 1 Then Return
		
		BonusObject1 = TCreationSnakeObject.Create(202)
		
		Local ObjConnect:TCreationObject = Null
		For Local Obj:TCreationObject = EachIn Cr.gcg(1).Objects
			If Obj.Group > (BonusObject1.Group-1) Then
				ObjConnect = Obj
				Exit
			End If
		Next
		
		Cr.AddCreationObject(BonusObject1,-1,ObjConnect,0,1)

		BonusObject2 = TCreationSnakeObject.Create(202)

		For Local Obj:TCreationObject = EachIn Cr.gcg(1).Objects
			If Obj.Group > (BonusObject2.Group-1) Then
				ObjConnect = Obj
				Exit
			End If
		Next
		
		Cr.AddCreationObject(BonusObject2,-1,ObjConnect,0,1)
		
		Activated = 1
	End Method

	Method Deactivate()
		If Cr = Null Then Return
		If Activated = 0 Then Return
		
		If BonusObject1 <> Null Then
			Cr.SubCreationObject(BonusObject1)
			BonusObject1 = Null
		End If

		If BonusObject2 <> Null Then
			Cr.SubCreationObject(BonusObject2)
			BonusObject2 = Null
		End If

		Activated = 0
	End Method
	
	Function Create:TBonusLifeDouble()
		Local b:TBonusLifeDouble = New TBonusLifeDouble
		
		b.BonusName = "LifeDoubleBonus"
		b.ActiveBonus = 0
		b.BonusState = 0
		
		Local bonus:TAnimationModel = GetResModel("Bonus_Model").CreateModel()
		
		b.BonusImage = bonus.GetAnimation("Bonus_03").Image
		
		bonus.Free()
		bonus = Null
		
		b.BonusCost = TBonusManager.GetBonusCost(b.BonusName)
		
		Return b
	End Function
	
End Type

