
Type TCreationAiDNAVirus Extends TCreationAi
	Const MinDist# = 400 * 400
	Const SpeedDefault# = 0.25
	Const SpeedMax# = 3.5
	
	Field Tactic%

	Field EnemyObject:TCreationObject
	
	Field CollisionID% = -1
	
	Method Update()
	
		Select Tactic
		Case 1
			AnimateValue(Creation.MoveSpeed,SpeedDefault,1)
			
			Local x1#,y1#,x2#,y2#,distq#
			Local distq_min#,distq_min_cr:TCreation
			
			distq_min = MinDist
			
			For Local cr:TCreation = EachIn Creations
				If cr.EatingEnable = 1 And cr <> Creation And cr.CreationType = "Snake" Then
					x1 = cr.gco(0).x
					y1 = cr.gco(0).y
					x2 = Creation.gco(0).x
					y2 = Creation.gco(0).y
					
					distq = (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
					
					If distq < MinDist And distq < distq_min Then
						distq_min = distq
						distq_min_cr = cr
					End If
				End If
			Next
			
			If distq_min_cr <> Null Then
				Enemy = distq_min_cr
				If Enemy.CreationObjects.Count() > 1 Then
					EnemyObject = Enemy.gco(Rand(1,Enemy.CreationObjects.Count()-1))
				Else
					EnemyObject = Enemy.gco(0)
				End If
				
				Tactic = 2
			End If
		Case 2
			If Enemy = Null Then
				Tactic = 1
				Return
			End If
			
			Local x1# = EnemyObject.x
			Local y1# = EnemyObject.y
			
			Local x2# = Creation.gco(0).x
			Local y2# = Creation.gco(0).y
			
			Local enemy_dist# = Sqr((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))

			Local lx# = ((x2 - x1)/enemy_dist)*200
			Local ly# = ((y2 - y1)/enemy_dist)*200
			
			AnimateValue(Creation.MoveSpeed,SpeedMax,0.2)
			Creation.MoveToPosition(x2-lx,y2-ly)
			
			If (enemy_dist*enemy_dist) > MinDist Then
				Tactic = 1
			End If
			
			If CollisionID > 0 Then
				
				Local coll:TCollisionRequest = WorldManager.CollisionManager.GetCollisions(CollisionID)

				For Local colld:TCollisionDouble = EachIn coll.CollisionObjects
					If colld.Creation = Enemy Then
						colld.CreationObject.Hp:-20
						If colld.CreationObject.Hp < 0 Then colld.CreationObject.Hp = 0

						Creation.OnDieFlag = 1
						Creation.SubCreationObject(Creation.gco(0))
						
						Free()
						Return
						
					End If
				Next
				
			End If
			
		Default
			Tactic = 1
		End Select
	
	End Method

	Method Free()
		Creation = Null
		
		Enemy = Null
		EnemyObject = Null
	End Method
	
	Method Serealize()
		Tactic = 1
	End Method
	
	Method Debug()
	End Method
	
	Method AddCollisions()
		CollisionID = WorldManager.CollisionManager.AddCollisionRequest(Creation,Creation.gco(0))
		
		Local coll:TCollisionRequest = WorldManager.CollisionManager.GetCollisions(CollisionID)
		coll.Filter_Eatable = 0
		
	End Method
	
	Function Create:TCreationAiDNAVirus(Creation:TCreation)
		Local ai:TCreationAiDNAVirus = New TCreationAiDNAVirus
		ai.AiType = "AiDNAVirus"
		
		ai.Creation = Creation
		
		Return ai
	End Function

	
End Type

