
Type TCreationAiJellyFish Extends TCreationAi
	Const MinDist# = 400 * 400
	Const SpeedDefault# = 4
	Const SpeedMax# = 10
	
	Field Tactic% '1 - simple, 2 - get away from enemy

	Field Timer#,Delta#
	Field BaseX#,BaseY#
	
	Field VirusTimer#
	
	Method Update()
		Select Tactic
		Case 1
			If jMilliSecs() - Timer > Delta Then
				Timer = jMilliSecs()
				Delta = Rand(2000,4000)
				BaseX = Rand(-Camera.GrapX*3,Camera.GrapX*3)
				BaseY = Rand(-Camera.GrapY*3,Camera.GrapY*3)
			End If
			
			AnimateValue(Creation.MoveSpeed,SpeedDefault,1)
			Creation.MoveToPosition(BaseX,BaseY)
			
			Local x1#,y1#,x2#,y2#,distq#
			Local distq_min#,distq_min_cr:TCreation
			
			distq_min = MinDist
			
			For Local cr:TCreation = EachIn Creations
				If cr.EatingEnable = 1 And cr <> Creation Then
					x1 = cr.gco(0).x
					y1 = cr.gco(0).y
					x2 = Creation.gco(0).x
					y2 = Creation.gco(0).y
					
					distq = (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
					
					If distq < MinDist And distq < distq_min Then
						distq_min = distq
						distq_min_cr = cr
					End If
				End If
			Next
			
			If distq_min_cr <> Null Then
				Enemy = distq_min_cr
				Tactic = 2
			End If
		Case 2
			If Enemy = Null Then
				Tactic = 1
				Return
			End If
			
			Local x1# = Enemy.gco(0).x
			Local y1# = Enemy.gco(0).y
			
			Local x2# = Creation.gco(0).x
			Local y2# = Creation.gco(0).y
			
			Local enemy_dist# = Sqr((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))

			Local lx# = ((x2 - x1)/enemy_dist)*200
			Local ly# = ((y2 - y1)/enemy_dist)*200
			
			AnimateValue(Creation.MoveSpeed,SpeedMax,0.2)
			Creation.MoveToPosition(lx+x2,ly+y2)
			
			If (enemy_dist*enemy_dist) > MinDist Then
				Tactic = 1
			End If
			
			Local deltatimer#
			
			If enemy_dist < 100 Then
				deltatimer = 1000
			Else
				deltatimer = 2500
			End If
			
			If jMilliSecs() - VirusTimer > deltatimer Then
				VirusTimer = jMillisecs()
				WorldManager.AddCreationToWorld(TCreationDNAVirus.Create())
				Local i% = Rand(0,Creation.CreationObjects.Count()-1)
				TCreation(Creations.Last()).SetPosition(Creation.gco(i).x,Creation.gco(i).y)
			End If
			
		Default
			Tactic = 1
		End Select
	
	End Method

	Method Free()
		Creation = Null
		Enemy = Null
	End Method
	
	Method Serealize()
		SerFloat(BaseX)
		SerFloat(BaseY)
		SerInt(Tactic)
		Enemy = Null
	End Method
	
	Method Debug()
	End Method
	
	Method AddCollisions()
	End Method
	
	Function Create:TCreationAiJellyFish(Creation:TCreation)
		Local ai:TCreationAiJellyFish = New TCreationAiJellyFish
		ai.AiType = "AiJellyFish"
		
		ai.Creation = Creation
		ai.Tactic = 1
		ai.BaseX = Rand(-Camera.GrapX*2,Camera.GrapX*2)
		ai.BaseY = Rand(-Camera.GrapY*2,Camera.GrapY*2)

		Return ai
	End Function
	
End Type

