
Type TCreationAiShell Extends TCreationAi
	Const MinDist# = 150*150
	Const SpeedDefault# = 2
	Const SpeedMin# = 0.5
	
	Field Tactic%

	Field Timer#,Delta#
	Field BaseX#,BaseY#
	
	Field NeedDistance#
	Field NeedAngle#
	
	Field Alpha#
	Field CurrentAlpha#
	
	Field Hiding%
	
	Method SetHiding(hide%)
		Hiding = hide
	
		Select hide
		Case 0
			NeedDistance = 60
			NeedAngle = -105
			Alpha = 1
			Creation.GodType = 0
		Case 1
			NeedDistance =  46.7
			NeedAngle = -270
			Alpha = 0
			Creation.GodType = 1
		Default
		End Select
	End Method
	
	Method AnimateHiding()
		Local haspeed# = 5
		
		AnimateValue(Creation.gcg(1).DragAngle,NeedAngle,5 )
		AnimateValue(Creation.gcg(1).DragDist,NeedDistance,0.4)
		
		If CurrentAlpha <> Alpha Then
			For Local i1% = 1 To 4
				For Local Obj:TCreationShellObject = EachIn Creation.gcg(i1).Objects
					For Local Anim:TAnimation = EachIn Obj.AnimImage.Animations
						Anim.ae = Alpha * 255
						Anim.change_color_speed = 10
					Next
				Next
			Next
			CurrentAlpha = Alpha
		End If
	End Method
	
	Method Update()
		AnimateHiding()

		Select Tactic
		Case 1
			If jMilliSecs() - Timer > Delta Then
				Timer = jMilliSecs()
				Delta = Rand(2000,4000)
				BaseX = Rand(-Camera.GrapX*3,Camera.GrapX*3)
				BaseY = Rand(-Camera.GrapY*3,Camera.GrapY*3)
			End If
			
			AnimateValue(Creation.MoveSpeed,TCreationAiShell.SpeedDefault,1)
			Creation.MoveToPosition(BaseX,BaseY)
			
			SetHiding(0)
			
			Local x1#,y1#,x2#,y2#,distq#
			Local distq_min#,distq_min_cr:TCreation
			
			distq_min = TCreationAiShell.MinDist
			
			x2 = Creation.gco(0).x
			y2 = Creation.gco(0).y
			
			For Local cr:TCreation = EachIn Creations
				If cr.EatingEnable = 1 And cr <> Creation Then
					x1 = cr.gco(0).x
					y1 = cr.gco(0).y
					
					distq = (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
					
					If distq < MinDist And distq < distq_min Then
						distq_min = distq
						distq_min_cr = cr
					End If
				End If
			Next
			
			If distq_min_cr <> Null Then
				Enemy = distq_min_cr
			
				x1# = Enemy.gco(0).x
				y1# = Enemy.gco(0).y
				
				Local r# = Creation.gco(0).r
			
				Local angle# = ATan2(y1-y2,x1-x2)
			
				r = r Mod 360
			
				Local a1# = r+60
				Local a2# = r-20
			
				If angle > Min(a1,a2) And angle < Max(a1,a2) Then
					Tactic = 1
					Enemy = Null
				Else
					Tactic = 2
				End If
			
			End If
		Case 2
			If Enemy = Null Then
				Tactic = 1
				Return
			End If
			
			Local x1# = Enemy.gco(0).x
			Local y1# = Enemy.gco(0).y
			
			Local x2# = Creation.gco(0).x
			Local y2# = Creation.gco(0).y
			
			Local enemy_dist# = Sqr((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))
			
			SetHiding(1)
			
			AnimateValue(Creation.MoveSpeed,TCreationAiShell.SpeedMin,0.2)
			
			If (enemy_dist*enemy_dist) > MinDist Then
				Tactic = 1
			End If
			
		Default
			Tactic = 1
			SetHiding(0)
		End Select
	End Method
	Method Free()
		Creation = Null
		Enemy = Null
	End Method
	
	Method Serealize()
		SerInt(Hiding)
		SetHiding(Hiding)
		SerInt(Tactic)
	End Method
	
	'Method DrawL(x1#,y1#,x2#,y2#)
	'	DrawLine Camera.GetScrX(x1),Camera.GetScrY(y1),Camera.GetScrX(x2),Camera.GetScrY(y2)
	'End Method
	
	'Field Testaa#
	
	Method Debug()
'		SetBlend ALPHABLEND
'		SetAlpha 1
'		SetColor 255,0,0
'		SetScale 1,1
'		SetRotation 0
'		
'		Local x# = Creation.gco(0).x
'		Local y# = Creation.gco(0).y
'		Local r# = Creation.gco(0).r
'		
'		If KeyHit(key_h) Then testaa:-5
'		If KeyHit(key_j) Then testaa:+5
'		
'		40 -> 60
'		
'		r = r Mod 360
'
'		Local a1# = r+60
'		Local a2# = r-10
'		
'		r:+testaa
'		SetColor 255,0,0
'		DrawL(x,y,x+Cos(a1)*300,y+Sin(a1)*300)
'		SetColor 255,255,0
'		DrawL(x,y,x+Cos(a2)*300,y+Sin(a2)*300)
'		
'		DrawText testaa,0,0
'		
'		
'		
'		If Enemy <> Null Then
'			Local x2# = Enemy.gco(0).x
'			Local y2# = Enemy.gco(0).y
'			
'			Local angle# = ATan2(y2-y,x2-x)
'			
'			If angle > Min(a1,a2) And angle < Max(a1,a2) Then
'				SetColor 0,255,0
'			Else
'				SetColor 0,0,255
'			End If
'			
'			
'			DrawL(x,y,x+Cos(angle)*300,y+Sin(angle)*300)
'			
'			DrawText r,0,0
'			DrawText angle,0,20
'			
'		End If
	End Method
	
	Method AddCollisions()
	End Method
	
	Function Create:TCreationAiShell(Creation:TCreation)
		Local ai:TCreationAiShell = New TCreationAiShell
		ai.AiType = "AiShell"
		
		ai.Creation = Creation
		ai.SetHiding(0)
		
		Return ai
	End Function

	
End Type

