
Type TCreationAiStar Extends TCreationAi

	Const MinDist# = 400 * 400
	Const SpeedDefault# = 0.25
	Const SpeedMax# = 1
	
	Field Tactic%

	Field VirusTimer#
	
	Method Update()
		Select Tactic
		Case 1
			AnimateValue(Creation.MoveSpeed,SpeedDefault,1)
			
			Local x1#,y1#,x2#,y2#,distq#
			Local distq_min#,distq_min_cr:TCreation
			
			distq_min = MinDist
			
			For Local cr:TCreation = EachIn Creations
				If cr.EatingEnable = 1 And cr <> Creation And cr.CreationType = "Snake" Then
					x1 = cr.gco(0).x
					y1 = cr.gco(0).y
					x2 = Creation.gco(0).x
					y2 = Creation.gco(0).y
					
					distq = (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
					
					If distq < MinDist And distq < distq_min Then
						distq_min = distq
						distq_min_cr = cr
					End If
				End If
			Next
			
			If distq_min_cr <> Null Then
				Enemy = distq_min_cr
				Tactic = 2
				VirusTimer = 0
			End If
			
		Case 2
			If Enemy = Null Then
				Tactic = 1
				Return
			End If
			Local x1# = Enemy.gco(0).x
			Local y1# = Enemy.gco(0).y
			Local x2# = Creation.gco(0).x
			Local y2# = Creation.gco(0).y
			Local enemy_dist# = (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
			
			AnimateValue(Creation.MoveSpeed,SpeedMax,0.2)
			
			If enemy_dist > MinDist Then
				Tactic = 1
			End If
			
			Local deltatimer#
			
			If enemy_dist < 100*100 Then
				deltatimer = 1000
			Else
				deltatimer = 2500
			End If
			
			If jMilliSecs() - VirusTimer > deltatimer Then
				VirusTimer = jMillisecs()
				WorldManager.AddCreationToWorld(TCreationDNAVirus.Create())
				Local i% = Rand(0,Creation.CreationObjects.Count()-1)
				TCreation(Creations.Last()).SetPosition(Creation.gco(i).x,Creation.gco(i).y)
			End If
		Default
			Tactic = 1
		End Select
	End Method

	Method Free()
		Creation = Null
		
		Enemy = Null
	End Method
	
	Method Serealize()
		Tactic = 1
		VirusTimer = 0
	End Method
	
	Method Debug()
	End Method
	
	Method AddCollisions()
	End Method
	
	Function Create:TCreationAiStar(Creation:TCreation)
		Local ai:TCreationAiStar = New TCreationAiStar
		ai.AiType = "AiStar"
		
		ai.Creation = Creation
		
		Return ai
	End Function

	
End Type

