
Type TCreationBonusObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	Field rot#
	
	Field ScaleRan#
	Field Img_model:TResourceAnimImage
	
	Field BonusType%
	
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method
	
	Method ChangeLevel(newlevel%)
		BonusType = newlevel
		level = newlevel

		Free()

		CreationModel = CreateNewModel("Bonus_Model")

		Local st$ = "Bonus_0"+BonusType
		
		CreationModel.SetAnimation(st)

		Img_model = CreationModel.GetAnimation(st).Image

		ScaleRan = 1.1 - Float(Rand(0,20)) / 100.0
	End Method
	
	Method SerealizeObject()
		SerFloat(rot)
		SerFloat(ScaleRan)
	End Method

	Method Free()
		If CreationModel <> Null Then
			CreationModel.Free()
		End If
		CreationModel = Null
		
		Img_model = Null
	End Method
	
	Method Draw()
		If BonusType <> 6 Then
			rot:+1 * dt
		'Else
		'	ScaleRan = float(rand(100,140))/100.0
		End If
		
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation rot
		'SetAlpha 1

		Local scx#,scy#
		scx = Img_model.Scale_x
		scy = Img_model.Scale_y
		Img_model.Scale_x :* ScaleRan
		Img_model.Scale_y :* ScaleRan

		CreationModel.Draw(x,y)
		
		Img_model.Scale_x = scx
		Img_model.Scale_y = scy
	End Method
	
	Function Create:TCreationBonusObject()
		Local cso:TCreationBonusObject = New TCreationBonusObject
		
		cso.ChangeLevel(1)
		
		cso.rot = 0
		cso.Eatable = 1
		Return cso
	End Function
	
End Type


Type TCreationBonus Extends TCreation

	Method Update()
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return

		Local bt% = TCreationBonusObject(obj).BonusType
		
		Select bt%
		Case 1
			Player.BonusManager.AddPasiveBonus("ShapesBonus",Player.Creation,1)
		Case 2
			Player.BonusManager.AddPasiveBonus("LifeBonus",Player.Creation,1)
		Case 3
			Player.BonusManager.AddPasiveBonus("LifeDoubleBonus",Player.Creation,1)
		Case 4
			'Player.BonusManager.AddPasiveBonus("LifeDoubleBonus",Player.Creation,1)
		Case 5
			Player.BonusManager.AddPasiveBonus("SpeedBonus",Player.Creation,1)
		Case 6
			Player.BonusManager.AddPasiveBonus("AntiDotBonus",Player.Creation,1)
		Case 7
			Player.BonusManager.AddPasiveBonus("FirstAidBonus",Player.Creation,1)
		Default
		End Select
		
		cr.Upgrade()
		
		'SubCreationObject(TCreationObject(CreationObjects.First()))
		Free()
		WorldManager.RemoveCreation(Self)
		
	End Method
	
	Method AddCollisionRequests()
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method SerializeCreation()
	End Method

	Function Create:TCreationBonus(Typ% = 0)
		Local cr:TCreationBonus = New TCreationBonus
		
		If Typ = 0 Then Typ = Rand(1,7)
		
		cr.MoveSpeed = 0.25
		cr.TurnSpeed = 0
		cr.AddCreationObject(TCreationBonusObject.Create())
		TCreationObject(cr.CreationObjects.Last()).ChangeLevel(Typ)
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiNull.Create(cr)
		
		cr.CreationType = "Bonus"
		
		cr.CreationMoneyType = 1
		cr.CreationPointsType = 1
	
		Return cr
	End Function

End Type
