
Type TCreationCircleObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	
	Method ChangeLevel(newlevel%)
	End Method
	
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method

	Method SerealizeObject()
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
	End Method
	
	Method Draw()
		'SetBlend LIGHTBLEND
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation r
		
		CreationModel.Draw(x,y)
	End Method
	
	Function Create:TCreationCircleObject()
		Local cso:TCreationCircleObject = New TCreationCircleObject
		cso.CreationModel = CreateNewModel("Snake_Object_2_Model")
		cso.CreationModel.SetAnimation("Main")
		cso.level = 1
		Return cso
	End Function
	
End Type


Type TCreationCircle Extends TCreation

	Field timer#,delta#,delta2#
	
	Method Update()
	
		If PlayerControlable = 0 Then
		
			Local xc#,yc#,count# = 0
			For Local p1:TCreationObject = EachIn CreationObjects
				xc :+ p1.x
				yc :+ p1.y
				count :+1
			Next
			
			xc = xc# / count#
			yc = yc# / count#

		End If
		
		UpdatePhysics()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return

	End Method
	
	Method Upgrade%(options%)
	End Method

	Method AddCollisionRequests()
	End Method

	Method SerializeCreation()
	End Method
	
	Function Create:TCreationCircle()
		Local cr:TCreationCircle = New TCreationCircle
		
		cr.MoveSpeed = 2
		cr.TurnSpeed = 5
		For Local i% = 0 To 25
			cr.AddCreationObject(TCreationCircleObject.Create())
		Next
		
		cr.Ai = TCreationAiNull.Create(cr)
		
		cr.CreationType = "Circle"
	
		Return cr
	End Function

End type