
Type TCreationDNAVirusObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	Field rot#

	Method ChangeLevel(newlevel%)
	End Method
	
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method

	Method SerealizeObject()
		SerFloat(rot)
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
	End Method
	
	Method Draw()
		rot:+1 * dt
		SetRotation rot
		CreationModel.Draw(x,y)
	End Method
	
	Function Create:TCreationDNAVirusObject()
		Local cso:TCreationDNAVirusObject = New TCreationDNAVirusObject

		cso.CreationModel = CreateNewModel("DNAVirus_Model")
		cso.CreationModel.SetAnimation("Main")
		
		cso.level = 1
		cso.Eatable = 1
		cso.rot = Rand(0,360)
		cso.spherecollision = 10
		
		Return cso
	End Function
	
End Type


Type TCreationDNAVirus Extends TCreation
	Method Update()
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return

		cr.Upgrade()
		SubCreationObject(TCreationObject(CreationObjects.First()))
	End Method
	
	Method SerializeCreation()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method

	Function Create:TCreationDNAVirus(Typ% = -1)
		Local cr:TCreationDNAVirus = New TCreationDNAVirus
		
		cr.AddCreationObject(TCreationDNAVirusObject.Create())
		cr.MoveSpeed = 2
		cr.TurnSpeed = 3
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiDNAVirus.Create(cr)
		
		cr.CreationType = "DNAVirus"
		
		cr.CreationMoneyType = 3
		cr.CreationPointsType = 3

		Return cr
	End Function

End Type
