
Rem
jellyfish object levels
1 Head
2 Tail
101 - 107 Simply objects
201 - Eatable Object
301 - 304 Bonus Objects
End Rem

Type TCreationJellyFishObject Extends TCreationObject
	Field AnimImage:TAnimationModel = Null
	
	Method SetWidthHeight()
		Width = AnimImage.Width()
		Height = AnimImage.Height()
	End Method
	
	Method ChangeLevel(newlevel%)
		level = newlevel
		Free()
		
		Eatable = 0
		
		Select level
		Case 1
			DistLim = 32
		Case 2
			DistLim = 8
		Case 101,102,103,401,402
			DistLim = 16
		Case 104,105,106,107
			DistLim = 28
		Case 201
			DistLim = 32
		Case 301,302,303,304
			DistLim = 32
		End Select
		
		Select level
			Case 1
				AnimImage = CreateNewModel("JellyFish_Model")
				AnimImage.SetAnimation("Main")
				AnimImage.SetAnimation("Main2")
				Group = -999
			Case 2
				AnimImage = CreateNewModel("Tail_Model")
				AnimImage.SetAnimation("Main")
				
				'AnimImage.GetAnimation("Main").ae = 255
				AnimImage.GetAnimation("Main").re = 255
				AnimImage.GetAnimation("Main").ge = 220
				AnimImage.GetAnimation("Main").be = 220
				
				Group = 999

			Case 101
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere1")
				Group = 6
			Case 102
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				Group = 5
			Case 103
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 4
			Case 104
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				Group = 3
			Case 105
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = 2
			Case 106
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = 1
			Case 107
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 0

			Case 301
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				Group = -1
			Case 302
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = -2
			Case 303
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = -3
			Case 304
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = -4

			Case 201
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("LiveSphere")
				Eatable = 1
				Group = -5

			Case 401
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere4")
				Group = 0
				
			Case 402
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere5")
				Group = 0

		End Select
		
		spherecollision = 16
	End Method

	Method SerealizeObject()
	End Method

	Method Free()
		If AnimImage <> Null Then AnimImage.Free()
		AnimImage = Null	
	End Method
	
	Method Draw()
		If jMilliSecs() < ShowTime Then Return
	
		'SetBlend LIGHTBLEND
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation r
		AnimImage.Draw(x,y)
		
		'If 0 And DragType = 2 Then
		'	SetBlend SOLIDBLEND
		'	SetAlpha 1
		'	SetScale 1,1
		'	SetRotation 0
		'	SetColor 0,255,0
		'	DrawLine Camera.GetScrX(xb),Camera.GetScrY(yb),Camera.GetScrX(x),Camera.GetScrY(y)
		'	SetColor 255,255,0
		'	DrawLine Camera.GetScrX(xb),Camera.GetScrY(yb),Camera.GetScrX(DXB),Camera.GetScrY(DYB)
		'	SetColor 255,0,0
		'	DrawLine Camera.GetScrX(DXB),Camera.GetScrY(DYB),Camera.GetScrX(x),Camera.GetScrY(y)
		'End If
		
	End Method
	
	Function Create:TCreationJellyFishObject(lvl% = 1)
		Local cso:TCreationJellyFishObject = New TCreationJellyFishObject
		cso.ChangeLevel(lvl)
		Return cso
	End Function
	
End Type


Type TCreationJellyFish Extends TCreation
	
	Method Update()
		For Local coll:TCollisionRequest = EachIn Collisions
			For Local colld:TCollisionDouble = EachIn coll.CollisionObjects
				If colld.Creation.PoisionLevel = 0 Then colld.Creation.SetPoision(1)
			Next
		Next
	
		UpdatePhysics(1)
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		Collisions.Clear()
		Collisions = Null
		
		DeleteAllObjects()
	End Method
	
	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return
		If obj.Eatable = 0 Then Return
		
		SubCreationObject(obj)
		cr.EatingLastTime = jMilliSecs() + 500

		If CreationFail() Then
			Local to_con% = Rand(1,2)
			For Local i% = 0 To to_con
				WorldManager.AddCreationToWorld(TCreationVirus.Create())
				TCreation(Creations.Last()).SetPosition(gco(0).x,gco(0).y)
			Next
			
			For Local cro:TCreationObject = EachIn CreationObjects
				CrSnakeExp(cro.x,cro.y)
			Next

			Free()
			WorldManager.RemoveCreation(Self)
		Else
			cr.Upgrade()
		End If
		
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Field Collisions:TList
	
	Method AddGroupColl(group%)
		'For Local obj:TCreationObject = EachIn gcg(group).Objects
		'	Local col% = WorldManager.CollisionManager.AddCollisionRequest(Self,obj)
		'	Local cols:TCollisionRequest = TCollisionRequest(WorldManager.CollisionManager.GetCollisions(col))
		'	cols.OnlyWithSnakeHead = 1
		'	Collisions.AddLast(cols)
		'Next
		
		Local col% = WorldManager.CollisionManager.AddCollisionRequest(Self,TCreationObject(gcg(group).Objects.Last()))
		Local cols:TCollisionRequest = TCollisionRequest(WorldManager.CollisionManager.GetCollisions(col))
		cols.OnlyWithSnakeHead = 1
		Collisions.AddLast(cols)
	End Method
	
	Method AddCollisionRequests()
		Collisions.Clear()
		
		AddGroupColl(4)
		AddGroupColl(5)
		AddGroupColl(6)
		AddGroupColl(7)
		AddGroupColl(8)
		AddGroupColl(9)
	End Method
	
	Method SerializeCreation()
		If Collisions = Null Then Collisions = New TList
	End Method
	
	Function Create:TCreationJellyFish()
		Local cr:TCreationJellyFish = New TCreationJellyFish
		
		cr.MoveSpeed = 2
		cr.TurnSpeed = 6
		
		cr.Collisions = New TList
		
		cr.SmothAddObjects = 0
		
		cr.AddCreationObject(TCreationJellyFishObject.Create())

		cr.AddCreationObject(TCreationJellyFishObject.Create(201),-1,Null,0,1)
		cr.AddCreationObject(TCreationJellyFishObject.Create(201),-1,Null,0,2)
		cr.AddCreationObject(TCreationJellyFishObject.Create(201),-1,Null,0,3)
		cr.gcg(1).SetSettings(cr.gcg(0),0,0,2,60)
		cr.gcg(2).SetSettings(cr.gcg(0),0,-30,2,60)
		cr.gcg(3).SetSettings(cr.gcg(0),0,30,2,60)
		
		Local dist# = 20
		
		Local drag_type% = 3
		
		For Local i% = 1 To 10
			If i < 5 Then
				cr.AddCreationObject(TCreationJellyFishObject.Create(402),-1,Null,0,4)
			Else
				cr.AddCreationObject(TCreationJellyFishObject.Create(401),-1,Null,0,4)
			End If
			If i = 10 Then cr.AddCreationObject(TCreationJellyFishObject.Create(2),-1,Null,0,4)
			TCreationObject(cr.CreationObjects.Last()).DragType = drag_type
		Next
		cr.gcg(4).SetSettings(cr.gcg(2),0,0,2,dist)
		cr.gcg(4).SetGroupAAmp()

		For Local i% = 1 To 10
			If i < 5 Then
				cr.AddCreationObject(TCreationJellyFishObject.Create(402),-1,Null,0,5)
			Else
				cr.AddCreationObject(TCreationJellyFishObject.Create(401),-1,Null,0,5)
			End If
			If i = 10 Then cr.AddCreationObject(TCreationJellyFishObject.Create(2),-1,Null,0,5)
			TCreationObject(cr.CreationObjects.Last()).DragType = drag_type
		Next
		cr.gcg(5).SetSettings(cr.gcg(2),0,0,2,dist)
		cr.gcg(5).SetGroupAAmp(-TCreationObject(cr.gcg(4).Objects.First()).DragAAmp + Rand(-20,20))

		For Local i% = 1 To 10
			If i < 5 Then
				cr.AddCreationObject(TCreationJellyFishObject.Create(402),-1,Null,0,6)
			Else
				cr.AddCreationObject(TCreationJellyFishObject.Create(401),-1,Null,0,6)
			End If
			If i = 10 Then cr.AddCreationObject(TCreationJellyFishObject.Create(2),-1,Null,0,6)
			TCreationObject(cr.CreationObjects.Last()).DragType = drag_type
		Next
		cr.gcg(6).SetSettings(cr.gcg(1),0,0,2,dist)
		cr.gcg(6).SetGroupAAmp()

		For Local i% = 1 To 10
			If i < 5 Then
				cr.AddCreationObject(TCreationJellyFishObject.Create(402),-1,Null,0,7)
			Else
				cr.AddCreationObject(TCreationJellyFishObject.Create(401),-1,Null,0,7)
			End If
			If i = 10 Then cr.AddCreationObject(TCreationJellyFishObject.Create(2),-1,Null,0,7)
			TCreationObject(cr.CreationObjects.Last()).DragType = drag_type
		Next
		cr.gcg(7).SetSettings(cr.gcg(1),0,0,2,dist)
		cr.gcg(7).SetGroupAAmp(-TCreationObject(cr.gcg(6).Objects.First()).DragAAmp + Rand(-20,20))

		For Local i% = 1 To 10
			If i < 5 Then
				cr.AddCreationObject(TCreationJellyFishObject.Create(402),-1,Null,0,8)
			Else
				cr.AddCreationObject(TCreationJellyFishObject.Create(401),-1,Null,0,8)
			End If
			If i = 10 Then cr.AddCreationObject(TCreationJellyFishObject.Create(2),-1,Null,0,8)
			TCreationObject(cr.CreationObjects.Last()).DragType = drag_type
		Next
		cr.gcg(8).SetSettings(cr.gcg(3),0,0,2,dist)
		cr.gcg(8).SetGroupAAmp()

		For Local i% = 1 To 10
			If i < 5 Then
				cr.AddCreationObject(TCreationJellyFishObject.Create(402),-1,Null,0,9)
			Else
				cr.AddCreationObject(TCreationJellyFishObject.Create(401),-1,Null,0,9)
			End If
			If i = 10 Then cr.AddCreationObject(TCreationJellyFishObject.Create(2),-1,Null,0,9)
			TCreationObject(cr.CreationObjects.Last()).DragType = drag_type
		Next
		cr.gcg(9).SetSettings(cr.gcg(3),0,0,2,dist)
		cr.gcg(9).SetGroupAAmp(-TCreationObject(cr.gcg(8).Objects.First()).DragAAmp + Rand(-20,20))
		
		cr.SmothAddObjects = 1
		
		cr.Ai = TCreationAiJellyFish.Create(cr)

		cr.CreationType = "JellyFish"
		
		cr.CreationMoneyType = 5
		cr.CreationPointsType = 5
	
		Return cr
	End Function

End Type
