'base creation object code

Type TCreationGroup
	Field GroupId%
	
	Field Objects:TList
	
	Field DragToGroup:TCreationGroup
	Field DragToNum%
	
	Field DragToObjectNum%
	Field DragToObject:TCreationObject
	
	Field DragSet% = 1
	Field DragType% = 0
	Field DragAngle# = 0
	Field DragDist# = 0
	
	Method FindNum%(Obj:TCreationObject Var)
		For Local i% = 0 To Objects.Count()-1
			If Objects.ValueAtIndex(i) = Obj Then
				Return i
			End If
		Next
		
		Obj = TCreationObject(Objects.Last())
		Return Objects.Count()-1
	End Method

	Method Find:TCreationObject(num% Var)
		If (Objects.Count()-1) < num Then num = Objects.Count() - 1
		Return TCreationObject(Objects.ValueAtIndex(num))
	End Method
	
	Method AddObj(obj:TCreationObject)
		Objects.AddLast(obj)
	End Method
	
	Method SetSettings(DragGroup:TCreationGroup,DragNum%,DAngle#,DType%,DDist#,DragToObj:TCreationObject = Null)
		DragToGroup = DragGroup
		DragToNum = DragNum
		DragAngle = DAngle
		DragType = DType
		DragDist = DDist
		DragToObject = DragToObj
		
		If DragToObj <> Null Then
			DragToObjectNum = DragToGroup.FindNum(DragToObject)
		Else
			DragToObjectNum = -1
		End If
		DragSet = 1
	End Method
	
	Method UpdatePhysics()
		If Objects.Count() = 0 Then Return
		
		If DragToGroup <> Null Then
			If DragSet = 1 Then
				TCreationObject(Objects.First()).Angle = DragAngle
				TCreationObject(Objects.First()).DragADist = DragDist
				TCreationObject(Objects.First()).DragType = DragType
			End If
			If DragToNum = -1 And DragToObject = Null Then
				TCreationObject(Objects.First()).DragTo(TCreationObject(DragToGroup.Objects.Last()))
			End If
			If DragToNum <> -1 Then
				TCreationObject(Objects.First()).DragTo(DragToGroup.Find(DragToNum))
			End If
			If DragToObjectNum <> -1 Then
				DragToObjectNum	= DragToGroup.FindNum(DragToObject)
				TCreationObject(Objects.First()).DragTo(DragToObject)
			End If
		End If
		For Local i% = 1 To Objects.Count() - 1
			TCreationObject(Objects.ValueAtIndex(i)).DragTo(TCreationObject(Objects.ValueAtIndex(i-1)))
		Next
	End Method
	
	Method Free()
		Objects.Clear()
		Objects = Null
		DragToGroup = Null
	End Method
	
	Method SetGroupAAmp(amp# = 0)
		If amp = 0 Then
			If Rand(0,2) = 1 Then
				amp = Rand(-100,-70)
			Else
				amp = Rand(100,70)
			End If
		End If
		For Local obj:TCreationObject = EachIn Objects
			obj.DragAAmp = amp
		Next
	End Method
	
	Method Serealize(cr:TCreation)
		Local drid% = -1
		If DragToGroup <> Null Then drid = DragToGroup.GroupId
		SerInt(drid)
		If drid <> -1 Then DragToGroup = cr.gcg(drid)
		
		If DragToObject <> Null Then
			DragToObjectNum	= DragToGroup.FindNum(DragToObject)
		End If
		SerInt(DragToObjectNum)
		If DragToObjectNum <> -1 And DragToGroup <> Null Then
			DragToObject = DragToGroup.Find(DragToObjectNum)
		End If
		
		SerInt(DragToNum)
		SerInt(DragSet)
		SerInt(DragType)
		SerFloat(DragAngle)
		SerFloat(DragDist)
	End Method
	
	Function Create:TCreationGroup()
		Local gr:TCreationGroup = New TCreationGroup
		gr.Objects = New TList
		gr.GroupId = 0
		gr.DragToGroup = Null
		gr.DragToNum = 0
		gr.DragToObjectNum = -1
		Return gr
	End Function
End Type

Type TCreationObject
	Field level%
	Field Hp# = 100
	Field Eatable% = 0
	Field Group% = 0
	Field ShowTime# = 0

	Field x#, y#, r#, spherecollision# = 16
	Field DistToLast# = 32
	Field DistLim# = 32
	
	Field CreationGroupId% = 0
	Field CreationInGroupNum% = 0
	
	Field Angle#
	Field xb#
	Field yb#
	Field DragADist#
	Field DragAAmp#
	
	Field DXB#,DYB#
	
	Field Width#
	Field Height#

	Method CollideWith%(Obj:TCreationObject)
		Local distq# = (x - Obj.x) * (x - Obj.x) + (y - Obj.y)*(y - Obj.y)
		If distq < (Obj.spherecollision + spherecollision)*(Obj.spherecollision + spherecollision) Then
			Return 1
		End If
		Return 0
	End Method
	
	Method Free() Abstract
	Method Draw() Abstract
	Method ChangeLevel(newlevel%) Abstract
	
	Field DragType% = 0 '0 - base, 1 - angle , 2 - hard angle, 3 - variable
	
	Method DragTo(Drag:TCreationObject,DragLenght# = -1)
		WorkDistance()
		
		Select DragType
		Case 0
			Local distance# = Drag.DistToLast#
			If DragLenght <> -1 Then distance = DragLenght

			WorkDrag(Drag.x,Drag.y,x,y,r,distance)
		Case 1
			DXB = Drag.x
			DYB = Drag.y
	
			Local distance# = Drag.DistToLast#
			If DragLenght <> -1 Then distance = DragLenght

			WorkDrag(Drag.x,Drag.y,xb,yb,r,distance)
		
			Local bang# = ATan2(yb - Drag.y,xb - Drag.x) + Angle
			x = Cos(bang)*DragADist+Drag.x
			y = Sin(bang)*DragADist+Drag.y
		
			r = -ATan2(x - Drag.x,y - Drag.y) - 90
		Case 2
			DXB = Drag.x
			DYB = Drag.y
	
			x = Cos(180 + Drag.r + Angle)*DragADist+Drag.x
			y = Sin(180 + Drag.r + Angle)*DragADist+Drag.y
		
			r = -ATan2(x - Drag.x,y - Drag.y) - 90
		Case 3
			DXB = Drag.x
			DYB = Drag.y
	
			Local distance# = Drag.DistToLast#
			If DragLenght <> -1 Then distance = DragLenght

			WorkDrag(Drag.x,Drag.y,xb,yb,r,distance)
			
			Local ro# = -ATan2(xb - Drag.x,yb - Drag.y) - 90

			Local x2# = (xb-Drag.x)*Cos(-ro) - (yb-Drag.y)*Sin(-ro)
			Local y2# = (yb-Drag.y)*Cos(-ro) + (xb-Drag.x)*Sin(-ro)
			
			Local num% = CreationInGroupNum
			y2 :+ 4*Sin(0.05 * Pi * jmillisecs() + num*distance*2 + DragAAmp)
			
			x = x2*Cos(ro) - y2*Sin(ro) + Drag.x
			y = y2*Cos(ro) + x2*Sin(ro) + Drag.y
		
			r = -ATan2(x - Drag.x,y - Drag.y) - 90
		Default
			RuntimeError "Unknown drag type : "+DragType
		End Select
	End Method
	
	Method WorkDistance()
		If DistToLast <> DistLim Then
			Local a# = Sgn(DistLim - DistToLast)
			DistToLast :+ a*dt
			If Abs(DistLim - DistToLast) < 2 Then DistToLast = DistLim
			If Abs(DistLim - DistToLast) > DistLim * 10 Then DistToLast = DistLim
		End If

		If jMilliSecs() < ShowTime Then
			DistToLast = 1
		End If
	End Method
	
	Method WorkDrag(ax# Var,ay# Var,bx# Var,by# Var,rotate# Var,distance#)
		Local K#,locx#
		
		If (by <> ay) And (bx <> ax) Then
			K = (by - ay) / (bx - ax)
		Else
			K = 0.000001
		End If
		
		Local Calc# = Sqr ( distance*distance / (K*K + 1) )
			
		If ay < by Then
			locx = Sgn(K) * Calc
		Else
			If ax < bx Then
				locx = Calc
			Else
				locx = - Calc
			EndIf
		EndIf
		bx = locx + ax
		by = locx * K + ay
			
		rotate = -ATan2(bx - ax,by - ay) - 90
	End Method
	
	Method SerealizeObject() Abstract
	Method Serealize()
		SerInt(level)
		ChangeLevel(level)
		
		SerFloat(x)
		SerFloat(y)
		SerFloat(r)
		SerFloat(spherecollision)
		SerFloat(DistToLast)
		SerFloat(DistLim)
		SerFloat(Hp)
		SerInt(Eatable)
		SerInt(group)
		SerFloat(Angle)
		SerFloat(xb)
		SerFloat(yb)
		SerFloat(DragAAmp)
		SerInt(DragType)
		SerInt(CreationGroupId)
		SerInt(CreationInGroupNum)
		SerFloat(DragADist)
		
		ShowTime = 0
	End Method
	
	Method SetWidthHeight() Abstract
	
	Method SetWidthHeightRotated()
		
	End Method
End Type
