
Type TCreationPortalLayer
	Field Layer:TResourceImage
	Field Rotation#
	Field RotationSpeed#
	
	'Field ColorDisable% = 0
	
	Field ColorR# = 255
	Field ColorG# = 255
	Field ColorB# = 255
	
	Field ColorRNeed# = 255
	Field ColorGNeed# = 255
	Field ColorBNeed# = 255
	
	Field ColorSpeed# = 2
	
	Method Free()
		Layer = Null
	End Method
	
	Method SetNeedColor(r#,g#,b#)
		ColorRNeed = r
		ColorGNeed = g
		ColorBNeed = b
	End Method
	
	Method Draw(Rot#,x#,y#)
		SetBlend ALPHABLEND
		SetColor ColorR,ColorG,ColorB
		SetScale 1,1
		SetAlpha 1
		
		SetRotation Rot + Rotation
		
		Layer.DrawResource(x,y)

		Rotation :+ (RotationSpeed * dt)
		'If ColorDisable = 0 Then
		AnimateValue(ColorR,ColorRNeed,ColorSpeed)
		AnimateValue(ColorG,ColorGNeed,ColorSpeed)
		AnimateValue(ColorB,ColorBNeed,ColorSpeed)
		'End If
	End Method
	
	Method Serealize()
		SerFloat(ColorR)
		SerFloat(ColorG)
		SerFloat(ColorB)
		
		SerFloat(ColorRNeed)
		SerFloat(ColorGNeed)
		SerFloat(ColorBNeed)

		SerFloat(ColorSpeed)
		
		SerFloat(Rotation)
		SerFloat(RotationSpeed)
		
		'SerInt(ColorDisable)
		
	End Method
	
	Function Create:TCreationPortalLayer(num%,cd% = 0)
		Local lay:TCreationPortalLayer = New TCreationPortalLayer
		lay.Layer = GetResImage("PortalLayer_"+num)
		lay.Rotation = Rand(0,360)
		lay.RotationSpeed = (Float((Rand(0)*2-1)*Rand(50,100)))/70
		'lay.ColorDisable = cd
		
		Return lay
	End Function

	Function CreateImg:TCreationPortalLayer(Img:TResourceImage,cd% = 0)
		Local lay:TCreationPortalLayer = New TCreationPortalLayer
		lay.Layer = Img
		lay.Rotation = Rand(0,360)
		lay.RotationSpeed = (Float((Rand(0)*2-1)*Rand(50,100)))/70
		'lay.ColorDisable = cd
		
		Return lay
	End Function
	
End Type

Type TCreationPortalObject Extends TCreationObject

	Field Layers:TList
	
	Method SetWidthHeight()
		Width = -1
		Height = -1
		For Local layer:TCreationPortalLayer = EachIn Layers
			If layer.Layer.Image().width > Width Then Width = layer.Layer.Image().width
			If layer.Layer.Image().height > Height Then Height = layer.Layer.Image().height
		Next
	End Method

	Method ChangeLevel(newlevel%)
		If level = newlevel Then Return
		
		Free()
		
		Layers = New TList
		
		For Local i% = 1 To 7
			Layers.AddLast(TCreationPortalLayer.Create(i))
		Next
		
		'Layers.AddLast(TCreationPortalLayer.CreateImg(GetResImage("UserScore_Ring1")))
		'Layers.AddLast(TCreationPortalLayer.CreateImg(GetResImage("UserScore_Ring2"),1))
		'Layers.AddLast(TCreationPortalLayer.CreateImg(GetResImage("UserScore_Ring3")))
		'Layers.AddLast(TCreationPortalLayer.CreateImg(GetResImage("UserScore_Ring4"),1))
		
		
		level = newlevel
	
	End Method
	
	Method SetBaseColor(r#,g#,b#)
		For Local layer:TCreationPortalLayer = EachIn Layers
			layer.SetNeedColor(r,g,b)
		Next
	End Method
	
	Method SerealizeObject()
	
		For Local layer:TCreationPortalLayer = EachIn Layers
			layer.Serealize()
		Next
		
	End Method

	Method Free()
		If Layers <> Null Then
			For Local layer:TCreationPortalLayer = EachIn Layers
				layer.Free()
			Next
			Layers.Clear()
			Layers = Null
		End If
	End Method
	
	Method Draw()
		For Local layer:TCreationPortalLayer = EachIn Layers
			Layer.Draw(r,x,y)
		Next
	End Method
	
	Function Create:TCreationPortalObject()
		Local cso:TCreationPortalObject = New TCreationPortalObject

		cso.ChangeLevel(1)
		
		cso.Eatable = 1
		cso.spherecollision = 32
		Return cso
	End Function
	
End Type


Type TCreationPortal Extends TCreation
	Field PortalType%
	Field LevelID%

	Method Update()
		UpdatePhysics()
	End Method
	
	Method SetPortalType(typ%)
		PortalType = typ
		
		Local obj:TCreationPortalObject = TCreationPortalObject(gco(0))
		
		Select PortalType
		Case 0
			obj.SetBaseColor(255,255,255)
		Case 1
			obj.SetBaseColor(64,255,64)
		Case 2
			obj.SetBaseColor(64,64,255)
		Case 3
			obj.SetBaseColor(64,255,255)
		Default
		End Select
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method
	
	Field BlockTime#
	
	Const BlockDeltaTime# = 1500

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If jMillisecs() < BlockTime Then Return
		
		If Player <> Null And cr = Player.Creation Then
			Select PortalType
			Case 1,2
				Local lvl:TLevel = WorldManager.CurrentWorld.FindLevel(LevelID)
				Local need_por:TCreationPortal = Null
				
				For Local por:TCreation = EachIn lvl.LevelCreations
					If por.CreationType = "Portal" Then
						If PortalType = 1 Then
							If TCreationPortal(por).PortalType = 2 And TCreationPortal(por).LevelID = WorldManager.CurrentWorld.CurrentLvl.LevelNum Then
								need_por = TCreationPortal(por)
								Exit
							End If
						Else
							If TCreationPortal(por).PortalType = 1 And TCreationPortal(por).LevelID = WorldManager.CurrentWorld.CurrentLvl.LevelNum Then
								need_por = TCreationPortal(por)
								Exit
							End If
						End If
					End If
				Next
				
				If need_por <> Null Then
					Local head:TCreationObject = cr.gco(0)
					Local por:TCreationObject = need_por.gco(0)
					
					Local deltax# = por.x - head.x
					Local deltay# = por.y - head.y
					
					Camera.camera_x:+deltax
					Camera.camera_y:+deltay
					
					cr.DragX:+deltax
					cr.DragY:+deltay

					For Local obj:TCreationObject = EachIn cr.CreationObjects
						obj.x:+deltax
						obj.y:+deltay
					Next
				End If

				WorldManager.CurrentWorld.ChangeLevel(LevelID)
			Case 3
				Local deltax# = -cr.gco(0).x
				Local deltay# = -cr.gco(0).y
					
				Camera.camera_x:+deltax
				Camera.camera_y:+deltay
					
				cr.DragX:+deltax
				cr.DragY:+deltay
				
				For Local obj:TCreationObject = EachIn cr.CreationObjects
					obj.x:+deltax
					obj.y:+deltay
				Next
				
				WorldManager.ChangeWorld(LevelID)
			End Select
		End If
	End Method
	
	Method AddCollisionRequests()
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method SerializeCreation()
		SerInt(PortalType)
		SerInt(LevelID)
		
		SetPortalType(PortalType)
		
		BlockTime = 0
	End Method

	Function Create:TCreationPortal()
		Local cr:TCreationPortal = New TCreationPortal
		
		cr.MoveSpeed = 0
		cr.TurnSpeed = 0
		cr.AddCreationObject(TCreationPortalObject.Create())
		cr.MoveAngle = 0
		
		cr.Ai = Null
		
		cr.CreationType = "Portal"
	
		Return cr
	End Function

End Type
'