
Type TCreationSeaWeedObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	
	Method ChangeLevel(newlevel%)
	End Method
	
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method
	
	Method SerealizeObject()
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
	End Method
	
	Method Draw()
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation 0

		CreationModel.Draw(x,y)
		
	End Method
	
	Function Create:TCreationSeaWeedObject()
		Local cso:TCreationSeaWeedObject = New TCreationSeaWeedObject
		cso.CreationModel = CreateNewModel("Seaweed_Model")
		cso.CreationModel.SetAnimation("Main")
		
		cso.level = 1
		
		Return cso
	End Function
	
End Type


Type TCreationSeaWeed Extends TCreation

	Method Update()
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method SerializeCreation()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return
	
		cr.Upgrade()
		SubCreationObject(TCreationObject(CreationObjects.First()))
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method

	Function Create:TCreationSeaWeed()
		Local cr:TCreationSeaWeed = New TCreationSeaWeed
		
		cr.AddCreationObject(TCreationSeaWeedObject.Create())
		cr.MoveSpeed = 0.25
		cr.TurnSpeed = 0
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiNull.Create(cr)
		
		cr.CreationType = "SeaWeed"
	
		Return cr
	End Function

End type