
Type TCreationShellObject Extends TCreationObject
	Field AnimImage:TAnimationModel = Null
	
	Method SetWidthHeight()
		Width = AnimImage.Width()
		Height = AnimImage.Height()
	End Method
	
	Method ChangeLevel(newlevel%)
		level = newlevel
		Free()
		
		Eatable = 0
		
		Select level
		Case 1
			DistLim = 32
		Case 2
			DistLim = 8
		Case 101,102,103
			DistLim = 16
		Case 401,402
			DistLim = 12
		Case 104,105,106,107
			DistLim = 28
		Case 201
			DistLim = 32
		Case 301,302,303,304
			DistLim = 32
		End Select
		
		Select level
			Case 1
				AnimImage = CreateNewModel("Shell_Model")
				AnimImage.SetAnimation("Main")
				Group = -999
			Case 2
				AnimImage = CreateNewModel("Tail_Model")
				AnimImage.SetAnimation("Main")
				Group = 999

			Case 101
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere1")
				Group = 6
			Case 102
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				Group = 5
			Case 103
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 4
			Case 104
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				Group = 3
			Case 105
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = 2
			Case 106
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = 1
			Case 107
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 0

			Case 301
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				Group = -1
			Case 302
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = -2
			Case 303
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = -3
			Case 304
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = -4

			Case 201
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("LiveSphere")
				Eatable = 1
				Group = -5
				
								
			Case 401
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere4")
				Group = 0
				
			Case 402
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere5")
				Group = 0

		End Select
		
		spherecollision = 16
	End Method

	Method SerealizeObject()
	End Method

	Method Free()
		If AnimImage <> Null Then AnimImage.Free()
		AnimImage = Null	
	End Method
	
	Method Draw()
		If jMilliSecs() < ShowTime Then Return
	
		'SetBlend LIGHTBLEND
		'SetColor 255,255,255
		If level <> 201 Then
			'SetScale 1,1
			SetRotation r
		Else
			'SetScale 0.8,0.8
			SetRotation r+100
		End If
		AnimImage.Draw(x,y)
		
	End Method
	
	Function Create:TCreationShellObject(lvl% = 1)
		Local cso:TCreationShellObject = New TCreationShellObject
		cso.ChangeLevel(lvl)
		Return cso
	End Function
	
End Type


Type TCreationShell Extends TCreation

	Method Update()
		UpdatePhysics(1)
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method SerializeCreation()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return
		If obj.Eatable = 0 Then Return
		
		SubCreationObject(obj)
		cr.EatingLastTime = jMilliSecs() + 500

		If CreationFail() Then
			Local to_con% = Rand(1,2)
			For Local i% = 0 To to_con
				WorldManager.AddCreationToWorld(TCreationVirus.Create())
				TCreation(Creations.Last()).SetPosition(gco(0).x,gco(0).y)
			Next
			
			For Local cro:TCreationObject = EachIn CreationObjects
				CrSnakeExp(cro.x,cro.y)
			Next

			Free()
			WorldManager.RemoveCreation(Self)
		Else
			cr.Upgrade()
		End If
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method

	Function Create:TCreationShell()
		Local cr:TCreationShell = New TCreationShell
		
		cr.AddCreationObject(TCreationShellObject.Create())
		
		cr.AddCreationObject(TCreationShellObject.Create(201),-1,Null,0,1)
		cr.gcg(1).SetSettings(cr.gcg(0),0,-105,2,60)
		
		For Local i% = 1 To 8
			If i < 5 Then
				cr.AddCreationObject(TCreationShellObject.Create(402),-1,Null,0,2)
			Else
				cr.AddCreationObject(TCreationShellObject.Create(401),-1,Null,0,2)
			End If
			TCreationObject(cr.CreationObjects.Last()).DragType = 1
			TCreationObject(cr.CreationObjects.Last()).DragADist = 16
			TCreationObject(cr.CreationObjects.Last()).Angle = -10
		Next
		cr.gcg(2).SetSettings(cr.gcg(1),0,-40,1,24)

		For Local i% = 1 To 8
			If i < 5 Then
				cr.AddCreationObject(TCreationShellObject.Create(402),-1,Null,0,3)
			Else
				cr.AddCreationObject(TCreationShellObject.Create(401),-1,Null,0,3)
			End If
			TCreationObject(cr.CreationObjects.Last()).DragType = 1
			TCreationObject(cr.CreationObjects.Last()).DragADist = 16
			TCreationObject(cr.CreationObjects.Last()).Angle = 10
		Next
		cr.gcg(3).SetSettings(cr.gcg(1),0,0,1,24)

		For Local i% = 1 To 8
			If i < 5 Then
				cr.AddCreationObject(TCreationShellObject.Create(402),-1,Null,0,4)
			Else
				cr.AddCreationObject(TCreationShellObject.Create(401),-1,Null,0,4)
			End If
		Next
		cr.gcg(4).SetSettings(cr.gcg(1),0,-20,1,24)
		
		
		cr.MoveSpeed = 2
		cr.TurnSpeed = 3
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiShell.Create(cr)
		
		cr.CreationType = "Shell"
		
		cr.CreationMoneyType = 5
		cr.CreationPointsType = 5
	
		Return cr
	End Function

End Type
