
Type TCreationSingleObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	Field rot#
	
	Field ScaleRan#
	Field Img_model:TResourceAnimImage
	
	Method ChangeLevel(newlevel%)
	
		level = newlevel
	
		Select level
		Case 1
			CreationModel = CreateNewModel("Single_Model")
		Case 2
			CreationModel = CreateNewModel("Single2_Model")
		Case 3
			CreationModel = CreateNewModel("Single3_Model")
		Case 4
			CreationModel = CreateNewModel("Single4_Model")
		Case 5
			CreationModel = CreateNewModel("Single5_Model")
		Default
			RuntimeError "Unknown Single Type "+level
		End Select
		
		CreationModel.SetAnimation("Main")
		
		ScaleRan = 1.1 - Float(Rand(0,20)) / 100.0
		Img_model = CreationModel.GetAnimation("Main").Image
	
	End Method
	
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method

	Method SerealizeObject()
		SerFloat(rot)
		SerFloat(ScaleRan)
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
		
		Img_model = Null
	End Method
	
	Method Draw()
		rot:+1 * dt
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation rot
		
		Local scx#,scy#
		scx = Img_model.Scale_x
		scy = Img_model.Scale_y
		Img_model.Scale_x :* ScaleRan
		Img_model.Scale_y :* ScaleRan

		CreationModel.Draw(x,y)
		
		Img_model.Scale_x = scx
		Img_model.Scale_y = scy
	End Method
	
	Function Create:TCreationSingleObject(Typ% = 1)
		Local cso:TCreationSingleObject = New TCreationSingleObject

		cso.ChangeLevel(Typ)
		
		cso.Eatable = 1
		cso.rot = Rand(0,360)
		cso.spherecollision = 10
		
		Return cso
	End Function
	
End Type


Type TCreationSingle Extends TCreation
	Method Update()
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return

		cr.Upgrade()
		SubCreationObject(TCreationObject(CreationObjects.First()))
	End Method
	
	Method SerializeCreation()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method

	Function Create:TCreationSingle(Typ% = -1)
		Local cr:TCreationSingle = New TCreationSingle
		
		If Typ = -1 Then Typ = Rand(1,5)
		
		cr.AddCreationObject(TCreationSingleObject.Create(Typ))
		cr.MoveSpeed = 0.25
		cr.TurnSpeed = 0
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiNull.Create(cr)
		
		cr.CreationType = "Single"
		
		cr.CreationMoneyType = 1
		cr.CreationPointsType = 1

		Return cr
	End Function

End type