
Type TCreationSnailObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	Field rot#
	
	Field ScaleRan#
	Field Img_model:TResourceAnimImage
			
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method
	
	Method ChangeLevel(newlevel%)
	End Method
	
	Method SerealizeObject()
		SerFloat(rot)
		SerFloat(ScaleRan)
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
		
		Img_model = Null
	End Method
	
	Method Draw()
		rot:+1 * dt
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation rot

		Local scx#,scy#
		scx = Img_model.Scale_x
		scy = Img_model.Scale_y
		Img_model.Scale_x :* ScaleRan
		Img_model.Scale_y :* ScaleRan

		CreationModel.Draw(x,y)
		
		Img_model.Scale_x = scx
		Img_model.Scale_y = scy
	End Method
	
	Function Create:TCreationSnailObject()
		Local cso:TCreationSnailObject = New TCreationSnailObject
		cso.CreationModel = CreateNewModel("Snail_Model")
		cso.CreationModel.SetAnimation("Main")
		
		cso.ScaleRan = 1.1 - Float(Rand(0,20)) / 100.0
		cso.Img_model = cso.CreationModel.GetAnimation("Main").Image

		cso.level = 1
		cso.Eatable = 1
		cso.rot = Rand(0,360)
		cso.spherecollision = 12
		
		Return cso
	End Function
	
End Type


Type TCreationSnail Extends TCreation

	Method Update()
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method SerializeCreation()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return
	
		cr.Upgrade()
		SubCreationObject(TCreationObject(CreationObjects.First()))
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method

	Function Create:TCreationSnail()
		Local cr:TCreationSnail = New TCreationSnail
		
		cr.AddCreationObject(TCreationSnailObject.Create())
		cr.MoveSpeed = 0.25
		cr.TurnSpeed = 0
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiNull.Create(cr)
		
		cr.CreationType = "Snail"
		
		cr.CreationMoneyType = 1
		cr.CreationPointsType = 1
	
		Return cr
	End Function

End type