
include "TCreationSnakeGenerator.bmx"

Rem
snake object levels
1 Head
2 Tail
101 - 107 Simply objects
201 - Eatable Object
301 - 304 Bonus Objects
401 - Bonus Object
End Rem

Type TCreationSnakeObject Extends TCreationObject

	Field AnimImage:TAnimationModel = Null
	
	Method Free()
		If AnimImage <> Null Then AnimImage.Free()
		AnimImage = Null
	End Method
	
	Method SetWidthHeight()
		Width = AnimImage.Width()
		Height = AnimImage.Height()
	End Method
		
	Method ChangeLevel(newlevel%)
		level = newlevel
		Free()
		
		Eatable = 0
		
		Select level
		Case 1
			DistLim = 32
		Case 2
			DistLim = 8
		Case 101,102,103
			DistLim = 20
		Case 104,105,106,107
			DistLim = 28
		Case 201,401
			DistLim = 32
		Case 301,302,303,304
			DistLim = 32
		End Select
		
		Select level
			Case 1
				AnimImage = CreateNewModel("Snake_Head_Model")
				AnimImage.SetAnimation("Main")
				Group = -999
			Case 2
				AnimImage = CreateNewModel("Tail_Model")
				AnimImage.SetAnimation("Main")
				Group = 999

			Case 101
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere1")
				Group = 6
			Case 102
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				Group = 5
			Case 103
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 4
			Case 104
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				Group = 3
			Case 105
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = 2
			Case 106
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = 1
			Case 107
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 0

			Case 301
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				Group = -4
			Case 302
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = -5
			Case 303
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = -6
			Case 304
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = -7

			Case 201
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("LiveSphere")
				Eatable = 1
				Group = -8

			Case 202
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("LiveSphere")
				Eatable = 1
				Group = -1
				
			Case 401
				AnimImage = CreateNewModel("Bonus_Model")
				AnimImage.SetAnimation("Bonus_01")
				Group = -2


		End Select
		
		'spherecollision = 16
	End Method
	
	Field EnableColorHp% = 1
	
	Method Draw()
		If jMilliSecs() < ShowTime Then Return
	
		If AnimImage<>Null Then
			If EnableColorHp = 1 Then
				For Local anim:TAnimation = EachIn AnimImage.Animations
					anim.ae = MinMaxTransport(Hp,32,255)
					
					anim.re = MinMaxTransport(Hp,136,255)
					anim.ge = MinMaxTransport(Hp,10,255)
					anim.be = MinMaxTransport(Hp,0,255)
				Next
			End If
		
			SetRotation r
			AnimImage.Draw(x,y)
		End If
		
	End Method
	
	Method SerealizeObject()
	End Method
	
	Function Create:TCreationSnakeObject(lvl% = 1)
		Local cso:TCreationSnakeObject = New TCreationSnakeObject
		cso.ChangeLevel(lvl)
		Return cso
	End Function
	
End Type


Type TCreationSnake Extends TCreation

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method
	
	Method Update()
		CheckEating()
		UpdatePhysics(1)
		For Local obj:TCreationObject = EachIn CreationObjects
			If obj.Eatable = 1 And obj.Hp = 0 Then
				SubCreationObject(obj)
			End If
		Next
		
		If CreationFail() Then
			If Player <> Null And Player.Creation = Self Then
				Player.Creation = Null
			End If
	
			Free()
			WorldManager.RemoveCreation(Self)
		End If
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()

		UpgradeObjects = Null
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return
		If obj.Eatable = 0 Then Return
		
		SubCreationObject(obj)
		cr.EatingLastTime = jMilliSecs() + 500

		If CreationFail() Then
			If Player <> Null And Player.Creation = Self Then
				Player.Creation = Null
				'Menu.RunInGameMenu()
			End If
			
			Local op# = 20.0
			Local opt1% = Rand(1,2)
			Local opt2% = Rand(2,4)

			For Local i% = 0 To opt1
				WorldManager.AddCreationToWorld(TCreationSnakeAdd.Create())
				TCreation(Creations.Last()).SetPosition(gco(0).x+Rand(-op,op),gco(0).y+Rand(-op,op))
			Next

			For Local i% = 0 To opt2
				WorldManager.AddCreationToWorld(TCreationVirus.Create())
				TCreation(Creations.Last()).SetPosition(gco(0).x+Rand(-op,op),gco(0).y+Rand(-op,op))
			Next
			
			For Local cro:TCreationObject = EachIn CreationObjects
				CrSnakeExp(cro.x,cro.y)
			Next

			Free()
			WorldManager.RemoveCreation(Self)
		Else
			cr.Upgrade()
		End If
	End Method
	
	Method SerializeCreation()
	End Method
	
	'this is useful method for develop our snake :)
	Method CheckEating()
		If EatingEnable = 0 Then Return
		
		If EatingProcess = 1 Then
			If TCreationSnakeObject(gco(0)).AnimImage.GetAnimation("Eat").enable = 0 Then TCreationSnakeObject(gco(0)).AnimImage.SetAnimation("Eat")
			If EatingLastTime < jMilliSecs() Then
				EatingProcess = 0
				EatingLastTime = 0
			End If
			Return
		Else
			If TCreationSnakeObject(gco(0)).AnimImage.GetAnimation("Main").enable = 0 Then TCreationSnakeObject(gco(0)).AnimImage.SetAnimation("Main")
		End If
		
		If CollisionHeadID < 0 Then Return
		
		Local coll:TCollisionRequest = WorldManager.CollisionManager.GetCollisions(CollisionHeadID)

		For Local colld:TCollisionDouble = EachIn coll.CollisionObjects
			EatingProcess = 1
			
			Local Eated% = 0
			If CreationGroup <> 0 Then
				If colld.Creation.CreationGroup <> CreationGroup Then
					colld.Creation.EatThis(Self,colld.CreationObject)
					Eated = 1
				End If
			Else
				colld.Creation.EatThis(Self,colld.CreationObject)
				Eated = 1
			End If
			
			If PlayerControlable = 1 Then
				If Eated = 1 Then
					Player.ScoreManager.AddPoints(colld.Creation.GetCreationPointsConst(),TScoreManager.AddScore)
					Player.ScoreManager.AddPoints(colld.Creation.GetCreationConst(),TScoreManager.AddMoney)
					Player.BonusManager.AddBonus("EatingBonus",Self)
					
					If colld.Creation.CreationType <> "Portal" Then
						If Creations.Contains(colld.Creation) Then
							If (colld.Creation.OnEating_SoundName) Then
								SoundLib.PlaySnd(colld.Creation.OnEating_SoundName)
							Else
								SoundLib.PlaySnd(Sound_OnEating)
							End If
						Else
							If (colld.Creation.OnDie_SoundName) Then
								SoundLib.PlaySnd(colld.Creation.OnDie_SoundName)
							Else
								SoundLib.PlaySnd(Sound_OnDie)
							End If
						End If
					End If
				End If
			End If

		Next
		
		coll = Null
	End Method
	
	Field CollisionHeadID% = -1
	
	Method AddCollisionRequests()
		CollisionHeadID = WorldManager.CollisionManager.AddCollisionRequest(Self,gco(0))
	End Method
	
	Field UpgradeMainObjectGroup% = 1
	
	Field UpgradeGroups% = 6
	Field MaxGroupCount% = 4
	Field DeLevelCount% = 2
	Field UpgradeGroupIndex% = 101
	Field UpgradeObjects:TList
	
	Method FindLastObjOfGroup:TCreationObject(Group%)
		Local l:TCreationObject = Null
		Local prev:TCreationObject
		For Local o:TCreationSnakeObject = EachIn UpgradeObjects
			If o.Group = Group Then
				l = prev
			End If
			prev = o
		Next
		Return l
	End Method
	Method UpgradeAddGroup(Group%)
		Local cro:TCreationObject = TCreationSnakeObject.Create(UpgradeGroupIndex+(UpgradeGroups-Group))
		AddCreationObject(cro,1,FindLastObjOfGroup(Group),1,UpgradeMainObjectGroup)
		cro.ShowTime = -1
	End Method
	
	Method UpgradeGroup%(i%,t% = 0)
		Local count% = 0
		For Local o:TCreationSnakeObject = EachIn UpgradeObjects
			If o.Group = i And o.Hp > 49 Then count:+1
		Next
		
		If count > MaxGroupCount Then
			DeLevelGroup(i%)
			Select t
			Case 0
				If i > 0 Then
					UpgradeAddGroup(i-1)
					Return 1
				End If
			Case 1
				If i > -7 Then
					UpgradeAddGroup(i-1)
					Return 1
				End If
			End Select
		End If
		Return 0
	End Method
	
	Method DeLevelGroup%(i%)

		Local l:TList = New TList
		Local count% = 0

		For Local o:TCreationSnakeObject = EachIn UpgradeObjects
			If o.Group = i and o.Hp > 49 Then
				l.AddLast(o)
				count :+1
			End If
		Next
		
		Local count2% = 0
		For Local o2:TCreationObject = EachIn l
			If count2 < count - DeLevelCount Then
				count2 :+1
				SubCreationObject(o2)
			Else
				Exit
			End If
		Next
		l.Clear()
		l = Null
	End Method
	
	Method Upgrade%(options%)
		UpgradeObjects = gcg(UpgradeMainObjectGroup).Objects
		
		Select options
		Case 0
			UpgradeGroups = 6
			MaxGroupCount = 4
			DeLevelCount = 2
			UpgradeGroupIndex = 101
			
			UpgradeAddGroup(UpgradeGroups)
			For Local i% = 0 To UpgradeGroups
				If UpgradeGroup(UpgradeGroups - i) = 0 Then Exit
			Next

			Local st# = 0
			Local time# = 0
			For Local obj:TCreationObject = EachIn UpgradeObjects

				time :+50
				If obj.ShowTime = -1 Then obj.ShowTime = jMilliSecs() + time
				
				If obj.Group <= UpgradeGroups Then
					CreationSnakeExplosion(obj,st)
					st :+ 50
				End If
			Next
			EatingProcess = 1
			EatingLastTime = jMilliSecs() + st
			
		Case 1
			UpgradeGroups = -4
			MaxGroupCount = 3
			DeLevelCount = 1
			UpgradeGroupIndex = 301
	
			UpgradeAddGroup(UpgradeGroups)
			For Local i% = 4 To 7
				If UpgradeGroup(-i,1) = 0 Then Exit
			Next
			
			Local st# = 0
			Local time# = 0
			For Local obj:TCreationObject = EachIn UpgradeObjects
			
				time :+50
				If obj.ShowTime = -1 Then obj.ShowTime = jMilliSecs() + time
				
				If obj.Group <= UpgradeGroups Then
					CreationSnakeExplosion(obj,st)
					st :+ 50
				End If
			Next
			EatingProcess = 1
			EatingLastTime = jMilliSecs() + st
			
		Default
			RuntimeError "Unknown snake upgrade option"
		End Select
		
	End Method

	Function Create:TCreationSnake(size%)
		Local cr:TCreationSnake = New TCreationSnake
		
		'size = 10
		
		cr.MoveSpeed = 2
		cr.TurnSpeed = 5
		
		cr.SmothAddObjects = 0
		
		cr.AddCreationObject(TCreationSnakeObject.Create(1),-1,Null,0,0) 'HEAD - group #0

		cr.AddCreationObject(TCreationSnakeObject.Create(201),-1,Null,0,1)
		cr.gcg(1).DragToGroup = cr.gcg(0)
		cr.gcg(1).DragToNum = 0

		For Local i% = 1 To size
			cr.AddCreationObject(TCreationSnakeObject.Create(101),-1,Null,0,1)
		Next

		cr.AddCreationObject(TCreationSnakeObject.Create(2),-1,Null,0,2) 'TAIL - group #2
		cr.gcg(2).DragToGroup = cr.gcg(1)
		cr.gcg(2).DragToNum = -1

		cr.SmothAddObjects = 1
		
		cr.EatingEnable = 1
	
		cr.Ai = TCreationAiSnake.Create(cr)
		
		cr.CreationType = "Snake"
		
		cr.CreationMoneyType = 6
		cr.CreationPointsType = 6

		Return cr
	End Function

End Type
