
Type TCreationSnakeAddObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	Field rot#
	
	Field ScaleRan#
	Field Img_model:TResourceAnimImage
	
	Method ChangeLevel(newlevel%)
	End Method
	
	Method SetWidthHeight()
		Width = CreationModel.Width()
		Height = CreationModel.Height()
	End Method
	
	Method SerealizeObject()
		SerFloat(rot)
		SerFloat(ScaleRan)
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
		
		Img_model = Null
	End Method
	
	Method Draw()
		rot:+1 * dt
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation rot
		'SetAlpha 1

		Local scx#,scy#
		scx = Img_model.Scale_x
		scy = Img_model.Scale_y
		Img_model.Scale_x :* ScaleRan
		Img_model.Scale_y :* ScaleRan

		CreationModel.Draw(x,y)
		
		Img_model.Scale_x = scx
		Img_model.Scale_y = scy
	End Method
	
	Function Create:TCreationSnakeAddObject()
		Local cso:TCreationSnakeAddObject = New TCreationSnakeAddObject
		cso.CreationModel = CreateNewModel("Add_Model")
		cso.CreationModel.SetAnimation("Main")
		
		cso.ScaleRan = 1.1 - Float(Rand(0,20)) / 100.0
		cso.Img_model = cso.CreationModel.GetAnimation("Main").Image
		
		cso.level = 1
		cso.rot = 0
		cso.Eatable = 1
		Return cso
	End Function
	
End Type


Type TCreationSnakeAdd Extends TCreation

	Method Update()
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return

		cr.Upgrade(1)
		SubCreationObject(TCreationObject(CreationObjects.First()))
	End Method
	
	Method AddCollisionRequests()
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method SerializeCreation()
	End Method

	Function Create:TCreationSnakeAdd()
		Local cr:TCreationSnakeAdd = New TCreationSnakeAdd
		
		cr.MoveSpeed = 0.25
		cr.TurnSpeed = 0
		cr.AddCreationObject(TCreationSnakeAddObject.Create())
		cr.MoveAngle = Rand(0,360)
		
		cr.Ai = TCreationAiNull.Create(cr)
		
		cr.CreationType = "SnakeAdd"
		
		cr.CreationMoneyType = 3
		cr.CreationPointsType = 3
	
		Return cr
	End Function

End Type
