

Type TCreationSnakeGeneratorPair
	Field Number%
	Field Count%
End Type

Type TCreationSnakeGeneratorNums
	Field List:TList
	
	Method AddNum(num%,count%)
		If Not List Then List = New TList
		Local pair:TCreationSnakeGeneratorPair = New TCreationSnakeGeneratorPair
		pair.Number = num
		pair.Count = count
		List.AddLast(pair)
	End Method
	
	Method GetValue%(random% = 1)
		If Not List Then Return -1
		Local pair:TCreationSnakeGeneratorPair
		If random = 1 Then
			pair = TCreationSnakeGeneratorPair(List.ValueAtIndex(Rand(0,List.Count()-1)))
		Else
			pair = TCreationSnakeGeneratorPair(List.First())
		End If
		pair.Count:-1
		If pair.Count < 1 Then List.Remove(pair)
		If List.Count() = 0 Then List = Null
		Return pair.Number
	End Method
End Type

Type TCreationSnakeGenerator
	Const SnakeSimple1% = 1
	Const SnakeSimple2% = 2
	Const SnakeSimple3% = 3
	Const SnakeSimple4% = 4
	Const SnakeSimple5% = 5

	Const SnakeMedium1% = 6
	Const SnakeMedium2% = 7
	Const SnakeMedium3% = 8
	Const SnakeMedium4% = 9
	Const SnakeMedium5% = 10

	Const SnakeHard1% = 11
	Const SnakeHard2% = 12
	Const SnakeHard3% = 13
	Const SnakeHard4% = 14
	Const SnakeHard5% = 15
	
	Function CreateSnake:TCreationSnake(SnakeType%)
	
		Local gen:TCreationSnakeGeneratorNums = New TCreationSnakeGeneratorNums
		Local basenum% = 3
		Local aggresive% = 0
		Local Snake:TCreationSnake
	
		Select SnakeType
		Case SnakeSimple1
			basenum = 1
		Case SnakeSimple2
			basenum = 2
		Case SnakeSimple3
			basenum = 2
			gen.AddNum(201,1)
			gen.AddNum(102,2)
		Case SnakeSimple4
			gen.AddNum(102,3)
			gen.AddNum(103,2)
			gen.AddNum(104,2)
			gen.AddNum(105,1)
			gen.AddNum(201,1)
		Case SnakeSimple5
			gen.AddNum(102,3)
			gen.AddNum(103,2)
			gen.AddNum(104,2)
			gen.AddNum(105,2)
			gen.AddNum(106,1)
			gen.AddNum(201,3)
		Case SnakeMedium1
			aggresive = 1
			gen.AddNum(102,3)
			gen.AddNum(103,2)
			gen.AddNum(201,1)
			gen.AddNum(401,1)
		Case SnakeMedium2
			aggresive = 1
			gen.AddNum(102,3)
			gen.AddNum(103,3)
			gen.AddNum(104,1)
			gen.AddNum(201,2)
			gen.AddNum(401,1)
		Case SnakeMedium3
			aggresive = 1
			gen.AddNum(102,3)
			gen.AddNum(103,3)
			gen.AddNum(104,3)
			gen.AddNum(201,2)
			gen.AddNum(401,2)
		Case SnakeMedium4
			aggresive = 1
			gen.AddNum(102,3)
			gen.AddNum(103,3)
			gen.AddNum(104,3)
			gen.AddNum(105,2)
			gen.AddNum(201,3)
			gen.AddNum(401,3)
		Case SnakeMedium5
			aggresive = 1
			gen.AddNum(102,3)
			gen.AddNum(103,3)
			gen.AddNum(104,3)
			gen.AddNum(105,2)
			gen.AddNum(106,2)
			gen.AddNum(201,3)
			gen.AddNum(401,5)
		Case SnakeHard1
			aggresive = 2
			gen.AddNum(102,3)
			gen.AddNum(103,1)
			gen.AddNum(201,1)
			gen.AddNum(401,1)
			gen.AddNum(301,1)
		Case SnakeHard2
			aggresive = 2
			gen.AddNum(102,3)
			gen.AddNum(103,2)
			gen.AddNum(104,1)
			gen.AddNum(201,4)
			gen.AddNum(401,2)
			gen.AddNum(301,2)
		Case SnakeHard3
			aggresive = 2
			gen.AddNum(102,3)
			gen.AddNum(103,3)
			gen.AddNum(104,2)
			gen.AddNum(105,1)
			gen.AddNum(201,5)
			gen.AddNum(401,2)
			gen.AddNum(301,3)
			gen.AddNum(302,2)
		Case SnakeHard4
			aggresive = 2
			gen.AddNum(102,2)
			gen.AddNum(103,2)
			gen.AddNum(104,3)
			gen.AddNum(105,2)
			gen.AddNum(106,1)
			gen.AddNum(201,7)
			gen.AddNum(401,3)
			gen.AddNum(301,2)
			gen.AddNum(302,3)
			gen.AddNum(303,1)
		Case SnakeHard5
			aggresive = 2
			gen.AddNum(102,3)
			gen.AddNum(103,3)
			gen.AddNum(104,3)
			gen.AddNum(105,3)
			gen.AddNum(106,3)
			gen.AddNum(107,3)
			gen.AddNum(201,8)
			gen.AddNum(401,5)
			gen.AddNum(301,3)
			gen.AddNum(302,3)
			gen.AddNum(303,3)
			gen.AddNum(304,3)
		End Select
		
		Snake = TCreationSnake.Create(basenum)
		
		TCreationAiSnake(Snake.Ai).Aggresive = aggresive
		
		Local num%
		While num <> -1
			num = Rand(0,10)
			If num < 8 Then num = 0
			If num > 7 Then num = 1
			num = gen.GetValue(num)
			If num <> -1 Then
				If num <> 401 Then
					Snake.AddCreationObject(TCreationSnakeObject.Create(num),-1,Snake.gco(1),1,1)
				Else
					Local BonusInObject:TCreationObject = TCreationSnakeObject.Create(num)
					Snake.AddCreationObject(BonusInObject,-1,Snake.gco(1),1,1)

					Local GroupId1% = Snake.Getgcid()
					Local GroupId2% = GroupId1 + 1
	
					For Local i% = 0 To 5
						Snake.AddCreationObject(TCreationSnakeObject.Create(101),-1,Null,0,GroupId1)
						TCreationObject(Snake.CreationObjects.Last()).DragType = 1
						TCreationObject(Snake.CreationObjects.Last()).DragADist = 16
						TCreationObject(Snake.CreationObjects.Last()).Angle = -30
					Next
					Snake.gcg(GroupId1).SetSettings(Snake.gcg(1),-1,-60,1,10,BonusInObject)

					For Local i% = 0 To 5
						Snake.AddCreationObject(TCreationSnakeObject.Create(101),-1,Null,0,GroupId2)
						TCreationObject(Snake.CreationObjects.Last()).DragType = 1
						TCreationObject(Snake.CreationObjects.Last()).DragADist = 16
						TCreationObject(Snake.CreationObjects.Last()).Angle = 30
					Next
					Snake.gcg(GroupId2).SetSettings(Snake.gcg(1),-1,60,1,10,BonusInObject)
				End If
			End If
		Wend
		
		Return Snake
	End Function
	
	
End Type

