
Type TCreationStarObject Extends TCreationObject
	Field AnimImage:TAnimationModel = Null
	
	Method SetWidthHeight()
		Width = AnimImage.Width()
		Height = AnimImage.Height()
	End Method
	
	Method ChangeLevel(newlevel%)
		level = newlevel
		Free()
		
		Eatable = 0
		
		Select level
		Case 1
			DistLim = 32
		Case 2
			DistLim = 8
		Case 101,102,103
			DistLim = 16
		Case 401,402
			DistLim = 12
		Case 104,105,106,107
			DistLim = 28
		Case 201
			DistLim = 32
		Case 301,302,303,304
			DistLim = 32
		End Select
		
		Select level
			Case 1
				AnimImage = CreateNewModel("Star_Model")
				AnimImage.SetAnimation("Main")
				AnimImage.SetAnimation("Main2")
				'AnimImage.SetAnimation("Main3")
				AnimImage.SetAnimation("Main4")
				Group = -999
			Case 2
				AnimImage = CreateNewModel("Tail_Model")
				AnimImage.SetAnimation("Main")
				Group = 999

			Case 101
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere1")
				Group = 6
			Case 102
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				Group = 5
			Case 103
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 4
			Case 104
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				Group = 3
			Case 105
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = 2
			Case 106
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = 1
			Case 107
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = 0

			Case 301
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				Group = -1
			Case 302
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere1")
				Group = -2
			Case 303
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				Group = -3
			Case 304
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Wings")
				AnimImage.SetAnimation("Sphere3")
				AnimImage.SetAnimation("Sphere2")
				AnimImage.SetAnimation("Sphere1")
				Group = -4

			Case 201
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("LiveSphere")
				Eatable = 1
				Group = -5
				
			Case 401
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere4")
				Group = 0
				
			Case 402
				AnimImage = CreateNewModel("Snake_Object_Model")
				AnimImage.SetAnimation("Sphere5")
				Group = 0


		End Select
		
		spherecollision = 16
	End Method

	Method SerealizeObject()
	End Method

	Method Free()
		If AnimImage <> Null Then AnimImage.Free()
		AnimImage = Null	
	End Method
	
	Method Draw()
		If jMilliSecs() < ShowTime Then Return
	
		'SetBlend LIGHTBLEND
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation r
		AnimImage.Draw(x,y)
		
		'If 0 And DragType = 1 Then
		'	SetBlend SOLIDBLEND
		'	SetAlpha 1
		'	SetScale 1,1
		'	SetRotation 0
		'	SetColor 0,255,0
		'	DrawLine Camera.GetScrX(xb),Camera.GetScrY(yb),Camera.GetScrX(x),Camera.GetScrY(y)
		'	SetColor 255,255,0
		'	DrawLine Camera.GetScrX(xb),Camera.GetScrY(yb),Camera.GetScrX(DXB),Camera.GetScrY(DYB)
		'	SetColor 255,0,0
		'	DrawLine Camera.GetScrX(DXB),Camera.GetScrY(DYB),Camera.GetScrX(x),Camera.GetScrY(y)
		'End If
		
	End Method
	
	Function Create:TCreationStarObject(lvl% = 1)
		Local cso:TCreationStarObject = New TCreationStarObject
		cso.ChangeLevel(lvl)
		Return cso
	End Function
	
End Type


Type TCreationStar Extends TCreation

	Method Update()
		MoveAngle:+1*dt
		UpdatePhysics()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method
	
	Method SerializeCreation()
	End Method

	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return
		If obj.Eatable = 0 Then Return
		
		SubCreationObject(obj)
		cr.EatingLastTime = jMilliSecs() + 500

		If CreationFail() Then
			Local to_con% = Rand(1,2)
			For Local i% = 0 To to_con
				WorldManager.AddCreationToWorld(TCreationVirus.Create())
				TCreation(Creations.Last()).SetPosition(gco(0).x,gco(0).y)
			Next
			
			For Local cro:TCreationObject = EachIn CreationObjects
				CrSnakeExp(cro.x,cro.y)
			Next

			Free()
			WorldManager.RemoveCreation(Self)
		Else
			cr.Upgrade()
		End If
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method

	Function Create:TCreationStar()
		Local cr:TCreationStar = New TCreationStar
		
		cr.AddCreationObject(TCreationStarObject.Create())
		
		cr.AddCreationObject(TCreationStarObject.Create(201),-1,Null,0,1)
		cr.gcg(1).SetSettings(cr.gcg(0),0,90 + 72*0,2,90)

		cr.AddCreationObject(TCreationStarObject.Create(201),-1,Null,0,2)
		cr.gcg(2).SetSettings(cr.gcg(0),0,90 + 72*1 - 10,2,90)

		cr.AddCreationObject(TCreationStarObject.Create(201),-1,Null,0,3)
		cr.gcg(3).SetSettings(cr.gcg(0),0,90 + 72*2 - 3,2,75)

		cr.AddCreationObject(TCreationStarObject.Create(201),-1,Null,0,4)
		cr.gcg(4).SetSettings(cr.gcg(0),0,90 + 72*3 + 6,2,75)

		cr.AddCreationObject(TCreationStarObject.Create(201),-1,Null,0,5)
		cr.gcg(5).SetSettings(cr.gcg(0),0,90 - 72*1 + 6,2,90)
		
		cr.MoveSpeed = 2
		cr.TurnSpeed = 3
		cr.MoveAngle = Rand(0,360)

		cr.Ai = TCreationAiStar.Create(cr)
		
		cr.CreationType = "Star"
		
		cr.CreationMoneyType = 4
		cr.CreationPointsType = 4
	
		Return cr
	End Function

End type