
Type TCreationVirusObject Extends TCreationObject
	Field CreationModel:TAnimationModel
	
	Field ScaleRan#
	Field Img_model1:TResourceAnimImage
	Field Img_model2:TResourceAnimImage
	
	Method ChangeLevel(newlevel%)
	End Method
	
	Method SetWidthHeight()
		Width = CreationModel.Width() * ScaleRan
		Height = CreationModel.Height() * ScaleRan
	End Method
	
	Method SerealizeObject()
		SerFloat(ScaleRan)
	End Method

	Method Free()
		CreationModel.Free()
		CreationModel = Null
		
		Img_model1 = Null
		Img_model2 = Null
	End Method
	
	Method Draw()
		'SetBlend LIGHTBLEND
		'SetColor 255,255,255
		'SetScale 1,1
		SetRotation r
		
		Local scx1#,scy1#
		Local scx2#,scy2#
		scx1 = Img_model1.Scale_x
		scy1 = Img_model1.Scale_y
		scx2 = Img_model2.Scale_x
		scy2 = Img_model2.Scale_y
		Img_model1.Scale_x :* ScaleRan
		Img_model1.Scale_y :* ScaleRan
		Img_model2.Scale_x :* ScaleRan
		Img_model2.Scale_y :* ScaleRan

		CreationModel.Draw(x,y)
		
		Img_model1.Scale_x = scx1
		Img_model1.Scale_y = scy1
		Img_model2.Scale_x = scx2
		Img_model2.Scale_y = scy2
	End Method
	
	Function Create:TCreationVirusObject()
		Local cso:TCreationVirusObject = New TCreationVirusObject
		
		cso.CreationModel = CreateNewModel("Virus_Model")
		cso.CreationModel.SetAnimation("Main2")
		cso.CreationModel.SetAnimation("Main3")
		
		cso.ScaleRan = 1.1 - Float(Rand(0,20)) / 100.0
		cso.Img_model1 = cso.CreationModel.GetAnimation("Main2").Image
		cso.Img_model2 = cso.CreationModel.GetAnimation("Main3").Image

		cso.level = 1
		cso.Eatable = 1
		Return cso
	End Function
	
End Type


Type TCreationVirus Extends TCreation
	
	Method Update()
		UpdatePhysics()
	End Method
	
	Method MoveToPosition(x#,y#)
		MoveToPositionBase(x,y)
	End Method
	Method SetPosition(x#,y#,angle# = 0)
		SetPositionBase(x,y,angle)
	End Method
	
	Method SerializeCreation()
	End Method
	
	Method Draw()
		DrawAllObjects()
	End Method
	
	Method Free()
		DeleteAllObjects()
	End Method

	Method EatThis(cr:TCreation,obj:TCreationObject)
		If GodType = 1 Then Return

		cr.Upgrade()
		SubCreationObject(TCreationObject(CreationObjects.First()))
	End Method
	
	Method Upgrade%(options%)
	End Method
	
	Method AddCollisionRequests()
	End Method
	
	Function Create:TCreationVirus()
		Local cr:TCreationVirus = New TCreationVirus
		
		cr.MoveSpeed = 1
		cr.TurnSpeed = 0.3
		cr.AddCreationObject(TCreationVirusObject.Create())
		
		cr.MoveAngle = Rand(0,360)
		cr.SetPositionBase(Rand(-Camera.GrapX,Camera.GrapX),Rand(-Camera.GrapY,Camera.GrapY))
		
		cr.Ai = TCreationAiSimple.Create(cr)
		
		cr.CreationType = "Virus"
		
		cr.CreationMoneyType = 1
		cr.CreationPointsType = 1
	
		Return cr
	End Function

End Type
