
Type TCursorModel
	Field Main:TResourceImage
	Field MainX#,MainY#
	
	Field Add1:TResourceImage
	Field Add1X#,Add1Y#
	
	Field Add2:TResourceImage
	Field Add2X#,Add2Y#
	
	Field IgnoreGlobalAlpha% = 1

	Method Free()
		Main = Null
		Add1 = Null
		Add2 = Null
	End Method
	
	Method Drag(x_to#,y_to#,x# Var,y# Var,dist#)
		Local locx#,Rad# = dist
		Local K#
		If x <> x_to And y <> y_to Then
			K = (y - y_to) / (x - x_to)
		Else
			K = 0.00001
		End If
		
		Local Calc# = Sqr ( Rad*Rad / (K*K + 1) )
			
		If y_to < y Then
			locx = Sgn(K) * Calc
		Else
			If x_to < x Then
				locx = Calc
			Else
				locx = - Calc
			EndIf
		EndIf
		x = locx + x_to
		y = locx * K + y_to
			
		'r = -ATan2(x - x_to,y - y_to) - 90
	End Method

	Method Draw(pos_x#,pos_y#,fl% = 0,alpha# = 1,cr# = 0,cg# = 0,cb# = 0,rot# = 0)
		Local galpha# = Camera.GlobalAlpha
		If IgnoreGlobalAlpha = 1 Then Camera.GlobalAlpha = 1

		SetBlend ALPHABLEND
		SetColor cr,cg,cb
		SetScale 0.2,0.2
		'SetRotation -90 + ATan2(TCreationSnake(Creation).Head.y - Camera.GetWorldX(MouseY()),TCreationSnake(Creation).Head.x - Camera.GetWorldX(MouseX()))
		SetAlpha alpha
		Local mx# = pos_x
		Local my# = pos_y
		
		Drag(mx,my,MainX,MainY,16)
		
		If fl = 0 Then
			SetRotation -ATan2(MainX - mx,MainY - my)
		Else
			SetRotation rot
		End If
		Main.DrawResource(MainX,MainY)

		SetRotation 0
		
		Drag(MainX,MainY,Add1X,Add1Y,18)
		Add1.DrawResource(Add1X,Add1Y)

		Drag(Add1X,Add1Y,Add2X,Add2Y,10)
		Add2.DrawResource(Add2X,Add2Y)
		
		Camera.GlobalAlpha = galpha
		
	End Method
	
	Function Create:TCursorModel()
		Local c:TCursorModel = New TCursorModel
		c.Main = GetResImage("Cursor1")
		c.Add1 = GetResImage("Cursor2")
		c.Add2 = GetResImage("Cursor3")
		Return c
	End Function
	
End Type


Type TCursor
	Field Cur:TCursorModel

	Method Free()
		Cur.Free()
		Cur = Null
	End Method
	
	Method Draw()
		Cur.Draw(Camera.GetWorldX(MouseX()),Camera.GetWorldY(MouseY()))
	End Method
	
	Function Create:TCursor()
		Local c:TCursor = New TCursor
		c.Cur = TCursorModel.Create()
		
		Return c
	End Function
End Type
