Type TEffectExplosion Extends TEffect
	Field Img:TResourceImage
	Field scx#,scy#
	Field alpha#

	Field StartTime#
	
	Field m# = 0.3
	Field s# = 0.05
	
	Field first%
	Field EnableDraw%
	
	Field cr#,cg#,cb#
	
	Method Update()
		If StartTime > jMilliSecs() Then
			Return
		Else
			EnableDraw = 1
		end if
		
		UpdatePos()
		
		scx :+ s*dt
		scy :+ s*dt
		
		If scx > m/2 Then
			alpha :- s*4*dt
		End If
		
		If scx >= m Then
			scx = m
			scy = m
		End If
		
		If first = 0 Then
			first = 1
			scx = 0
			scy = 0
			'alpha = 0
		End If
		
		If alpha < 0 Then
			Free()
		End If
	End Method
	
	Method Draw()
		If EnableDraw = 0 Then Return
		
		SetBlend ALPHABLEND
		SetAlpha alpha
		SetScale scx,scy
		SetRotation 0
		SetColor cr,cg,cb
		
		Img.DrawResource(x,y)
	End Method
	
	Method Free()
		Img = Null
		Obj = Null
		Effects.Remove(Self)
	End Method
	
	Function Create:TEffectExplosion(x#,y#,St# = 0)
		Local e:TEffectExplosion = New TEffectExplosion
		e.Img =	GetResImage("Fx_Explosion")
		e.scx = 0
		e.scy = 0
		e.alpha = 1
		e.x = x
		e.y = y
		e.StartTime = jMilliSecs() + St
		
		e.cr = 255
		e.cg = 255
		e.cb = 255
		
		Effects.AddLast(e)
		Return e
	End Function

End Type
