
Include "TGuiProgressBar.bmx"
Include "TGuiButton.bmx"

Type TGuiElement
	Field Visible% = 1
	Field x#,y#,w#,h#

	Method Free() Abstract
	Method Update() Abstract
	Method Draw() Abstract
	
	Method IsVisible%()
		Return Visible
	End Method
	Method SetVisible(vis%)
		Visible = vis
	End Method
End Type

Type TGui
	Field GuiElements:TList

	Method Free()
		For Local ge:TGuiElement = EachIn GuiElements
			ge.Free()
		Next
		GuiElements.Clear()
		GuiElements = Null
		
	End Method
	
	Method Update()
		For Local ge:TGuiElement = EachIn GuiElements
			If ge.IsVisible() = 1 Then
				ge.Update()
			End If
		Next
	End Method
	
	Method Draw()
		For Local ge:TGuiElement = EachIn GuiElements
			If ge.IsVisible() = 1 Then
				ge.Draw()
			End If
		Next
	End Method
	
	'this code originally from HighGui3
	Method DrawFrameRect(x#, y#, w#, h#, image:TImage, group% = 0, DrawTop% = True, drawEnd% = True)
		Local xt#
		
		If drawEnd = False Then
			w:+image.width
		End If
		Local fo# = group * 9
		If DrawTop Then
			DrawImage image, x, y, 0 + fo
			DrawImageRect image, x + image.width, y, w - (image.width * 2), image.height, 1 + fo
			If drawEnd Then
				DrawImage image, (x + w) - (image.width), y, 2 + fo
			End If
		EndIf

		DrawImageRect image, x, y + image.height, image.width, h - (image.height * 2), 3 + fo
		DrawImageRect image, x + image.width, y + image.height, w - (image.width * 2), h - (image.height * 2), 4 + fo
		If drawEnd Then
			DrawImageRect image, (x + w) - (image.width), y + image.height, image.width, h - (image.height * 2), 5 + fo
		End If

		DrawImage image, x, (y + h) - (image.height), 6 + fo
		DrawImageRect image, x + image.width, (y + h) - (image.height), w - (image.width * 2), image.height, 7 + fo
		If drawEnd Then
			DrawImage image, (x + w) - (image.width), (y + h) - (image.height), 8 + fo
		End If
	End Method

	
	Function CreateGui:TGui()
		Gui = New TGui
		Gui.GuiElements = New TList
	End Function
	
	
	'-------------------- LOADING BAR -----------------------------
	Field LoadingCurrentState%
	Field LoadingMaxState% = 165
	Field LoadingCountStates% = 0
	Field LoadingBarGui:TGuiProgressBar
	Field LoadingImage:TResourceImage
	
	Function LoadingBarInit()'draw first loading screen
		SetClsColor 0,155,208
		Cls
		Flip 0
	End Function
	
	Method LoadingBar(StateValues% = 1)'work with loading screen

		'if loading bar isnt ever created - please create them
		If LoadingBarGui = Null Then
			LoadingBarGui = TGuiProgressBar.Create(GraphicsWidth() / 2 - 100,GraphicsHeight() / 2 + 32,200,20)
		End If
		
		If LoadingImage = Null Then
			LoadingImage = GetResImage("Menu_PleaseWaitLoading")
		End If
		
		'add states
		LoadingCurrentState:+StateValues
		
		'check if max states < current states .. them recalculate max states
		If LoadingCurrentState > LoadingMaxState Then
			LoadingMaxState = LoadingCurrentState
		End If
		
		'setup progress bar values
		LoadingBarGui.SetValue(LoadingCurrentState,LoadingMaxState)
		
		'update gui module
		Gui.Update()
		
		'draw loading screen
		SetClsColor 0,155,208
		Cls
		DrawImage LoadingImage.Image(),GraphicsWidth() / 2,GraphicsHeight() / 2
		Gui.Draw()
		Flip
		
		'If KeyHit(key_f6) Game.ScreenShot()
	End Method
	Method LoadingBarClose() 'close loading bar
		'free loading bar
		LoadingBarGui.Free()
		LoadingImage = Null
		
		'if we need to calculate this shit - get fuck out message
		If LoadingCountStates = 1 Then
			RuntimeError "LoadingBar Maximum up to "+LoadingMaxState+" !!!"
		End If
		
		'clear screen
		Cls
		Flip 0
	End Method
	
End Type
