
Type TGuiProgressBar Extends TGuiElement

	Field Frame:TResourceAnimImage
	Field Bar:TResourceAnimImage
	
	Field ValueInPer# = 0

	Method Free()
		Frame = Null
		Bar = Null
		
		Gui.GuiElements.Remove(Self)
	End Method
	
	Method Update()
		
	End Method
	
	Method Draw()
		SetRotation 0
		SetAlpha 1
		SetBlend ALPHABLEND
		SetColor 255,255,255
		SetScale 1,1
		
		Gui.DrawFrameRect(x,y,w,h,Frame.Image())
		Local barWidth#
		barWidth = w - (Frame.Image().width * 2)
		barWidth = (ValueInPer / 100.0) * barWidth
		DrawImageRect Bar.Image(), x + Frame.Image().width, y + Frame.Image().height, barWidth, h - (Frame.Image().height * 2)
	End Method
	
	Method SetValue(value#,max_value# = 100)
		ValueInPer = (value / max_value) * 100
	End Method
	
	Function Create:TGuiProgressBar(x#,y#,w#,h#)
		Local ge:TGuiProgressBar = New TGuiProgressBar
		
		ge.Frame = GetResAnimImage("ProgressBar_Back")
		ge.Bar = GetResAnimImage("ProgressBar_Front")
		
		ge.x = x
		ge.y = y
		ge.w = w
		ge.h = h
		
		Gui.GuiElements.AddLast(ge)
		
		Return ge
	End Function
End Type
