
'   menu :(

Type TMenuButton
	Field Creation:TCreationMenu
	Field Name$
	Field Group%
	
	Method Free()
		Creation.FreeMenu()
		Creation = Null
	End Method
	
	Method Collision%(mx#,my#,x#,y#,w#,h#)
		Local wd# = w/2.0
		Local hd# = h/2.0
		If mx>x-wd And mx<x+wd And my>y-hd And my<y+hd Then Return 1
	End Method
	
	Method Click%()
		If Creation.ButtonEnable = 0 Then Return 0
		
		If Collision(Camera.GetWorldX(MouseX()),Camera.GetWorldY(MouseY()),Creation.GetX(),Creation.GetY(),Creation.GetW(),Creation.GetH()) Then
			Creation.SetActive(1)
			If Key.IsMouseHit(1) Then
				Return 1
			End If
		Else
			Creation.SetActive(0)
		End If
	End Method
	Method AddToWorld()
		WorldManager.AddCreationToWorld(Creation)
	End Method
	Function Create:TMenuButton(Name$,Img:TResourceImage,x#,y#,Group%,typ% = -1)
		Local b:TMenuButton = New TMenuButton
		
		b.Name = Name

		If typ = -1 Then
			b.Creation = TCreationMenu.Create(Img,x,y,Rand(1,4))
		Else
			b.Creation = TCreationMenu.Create(Img,x,y,typ)
		End If
		b.Creation.SetPosition(x,y)
		
		b.Group = Group
		
		Menu.Buttons.AddLast(b)
		
		Return b
	End Function
End Type

Type TMenu
	'Field jAquaLogo:TResourceImage
	Field jAquaLogo_Text:TTextAppear
	'Field JgsLogo:TResourceImage
	Field JgsLogo_Text:TTextAppear
	'Field YotsubaFon:TResourceImage
	Field AboutLogo:TAnimationModel
	
	Field Buttons:TList
	
	Field State% = 0
	Field Alpha# = 0
	Field LastTime% = 0
	
	Method GetButton:TMenuButton(name$)
		For Local b:TMenuButton = EachIn Buttons
			If b.Name = name Then
				Return b
			End If
		Next
	End Method
	Method SetStateToButtons:TMenuButton(state%,Group%)
		For Local b:TMenuButton = EachIn Buttons
			If b.Group = Group Then
				b.Creation.State = state
			End If
		Next
	End Method
	
	Method Free()
		'jAquaLogo = Null
		jAquaLogo_Text.Free()
		jAquaLogo_Text = Null
		'JgsLogo = Null
		'YotsubaFon = Null
		JgsLogo_Text.Free()
		JgsLogo_Text = Null
		
		PauseImage = Null
		
		AboutLogo.Free()
		AboutLogo = Null
		
		For Local b:TMenuButton = EachIn Buttons
			b.Free()
		Next
		Buttons.Clear()
		Buttons = Null
	End Method
	
	Field CurrentGrapMode:TMenuButton
	Field CurrentFullscreen%
	Field CurrentLoadSaveSlot%
	Field CurrentLoadSaveSlot2%
	
	Field GrapSlot1x#,GrapSlot1y#
	Field GrapSlot2x#,GrapSlot2y#
	Field GrapSlot3x#,GrapSlot3y#
	
	Method ChangeCurrentGrapModeButton(NewButton:TMenuButton)
		If CurrentGrapMode = NewButton Then Return

		If CurrentGrapMode <> Null Then
			Local x_n#,y_n#
			x_n = CurrentGrapMode.Creation.bx
			y_n = CurrentGrapMode.Creation.by

			CurrentGrapMode.Creation.bx = NewButton.Creation.bx
			CurrentGrapMode.Creation.by = NewButton.Creation.by
			CurrentGrapMode.Creation.State = 1

			NewButton.Creation.bx = x_n
			NewButton.Creation.by = y_n
			NewButton.Creation.State = 1
			CurrentGrapMode = NewButton
		
		End If

	End Method
	
	Rem
			Menu Update States :
			0 - init, delay 1000
			1 - alpha to 1, draw jgs logo
			2 - alpha to 0, draw jgs logl
			3 - alpha to 1, draw jaqua logo
			4 - alpha to 0, draw jaqua logo
			5 - init main menu
			6 - alpha to 1
			7 - set alpha 1
			8 - main menu cycle
			9 - about menu
			10 - load\save menu
			11 - config menu
			12 - main cycle INGAME menu
			13 - stop ingame menu
			14 - save\load ingame menu
			15 - select level MAIN menu
			16 - user snake editor
			17 - user bonus shop
			18 - game pause
			19 - exit from pause
	
		End Rem
		
	Field angl#
	Method Update()
		If State >= 0 And State <= 4 And key.IsMouseHit(1) Then RunMenu()

		Select State
		Case 6,7,8,10,11,15,16,17
			TileMap.PositionX = 1024*Cos(angl)
			TileMap.PositionY = 1024*Sin(angl)
			angl:+0.05*dt
		End Select

		Local camx#,camy#
		camx = Camera.camera_x
		camy = Camera.camera_y
		Camera.camera_x = 0
		Camera.camera_y = 0
		
		Select State
		Case 5
			WorldManager.ChangeWorld(999,0,0)
			Game.GameRuning = 0
			Game.EnableGameUpdate = 0
			Game.EnableGameDraw = 0

			For Local b:TMenuButton = EachIn Buttons
				If b.Group < 4 Or b.Group = 6 Then
					b.AddToWorld()
				End If
			Next
			
			SetStateToButtons(4,1)
			SetStateToButtons(4,2)
			SetStateToButtons(4,3)
			SetStateToButtons(4,6)

			For Local b:TMenuButton = EachIn Buttons
				If b.Group < 4 Or b.Group = 6 Then
					b.Creation.Update()
				End If
			Next
			
		Case 6,7,8,10,11,12,13,14,15,16,17,18,19
			Game.EnableGameUpdate = 1
			Game.EnableGameDraw = 1
		
		Default
			Game.EnableGameUpdate = 0
			Game.EnableGameUpdate = 0
		End Select
		
		If State = 12 Or State = 13 Or State = 14 Or State = 16 Or State = 17 Then
			For Local b:TMenuButton = EachIn Buttons
				If b.Group = 4 Or b.Group = 5 Or b.Group = 7 Or b.Group = 8 Then
					b.Creation.Update()
				End If
			Next
		End If
		
		
		'If key.IsKeyHit(key_q) Then SetStateToButtons(1,1)
		'If key.IsKeyHit(key_w) Then SetStateToButtons(2,1)
		
'		If key.IsKeyHit(key_e) Then
'			Player.UserSnakeEditor.SetEnable(1)
'			State = 16
'			Game.PauseGameAlpha = 0
'			TileMap.SetEnableForciblyPosition(1)
'		End If
'		
'		
		If State > 11 And State < 14 Then
			'Player.UserSnakeEditor.Update()
			Player.BonusShop.Update()
		End If
		
		Select State
			Case 0
				Alpha = 0
				If MilliSecs() - LastTime > 1000 Then State = 1
			Case 1
				'Alpha :+ 0.01 * dt
				'If Alpha >= 1 Then State = 2
				JgsLogo_Text.Update()
				If JgsLogo_Text.StateOn.StateName = "Stop" Then
					Alpha = 0.4
					State = 2
				End If
			Case 2
				Alpha :- 0.01 * dt
				If Alpha <= 0 Then State = 3 
			Case 3
				'Alpha :+ 0.01 * dt
				'If Alpha >= 1 Then State = 4
				jAquaLogo_Text.Update()
				If jAquaLogo_Text.StateOn.StateName = "Stop" Then State = 5
			Case 4
				Alpha :- 0.01 * dt
				If Alpha <= 0 Then State = 5
			Case 5
				Alpha = 0
				State = 6
				SetStateToButtons(1,1)
			Case 6
				Alpha :+ 0.02 * dt
				If Alpha >= 1 Then State = 7
			Case 7
				Alpha = 1
				State = 8
			Case 8
				If GetButton("NewGame").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(1,6)
					SetStateToButtons(2,1)
					State = 15
				End If
				If GetButton("LoadGame").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(1,2)
					SetStateToButtons(2,1)
					State = 10
					CurrentLoadSaveSlot = 0
					
					If Game.IsSaveSlotEmpty("Slot1") = 1 Then
						GetButton("Slot1").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot1").Creation.GetObj().MenuText = GetResImage("Menu_Slot1")
					End If
					If Game.IsSaveSlotEmpty("Slot2") = 1 Then
						GetButton("Slot2").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot2").Creation.GetObj().MenuText = GetResImage("Menu_Slot2")
					End If
					If Game.IsSaveSlotEmpty("Slot3") = 1 Then
						GetButton("Slot3").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot3").Creation.GetObj().MenuText = GetResImage("Menu_Slot3")
					End If
					If Game.IsSaveSlotEmpty("Slot4") = 1 Then
						GetButton("Slot4").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot4").Creation.GetObj().MenuText = GetResImage("Menu_Slot4")
					End If
					If Game.IsSaveSlotEmpty("Slot5") = 1 Then
						GetButton("Slot5").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot5").Creation.GetObj().MenuText = GetResImage("Menu_Slot5")
					End If
				End If
				If GetButton("Config").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(1,3)
					SetStateToButtons(2,1)
					State = 11

					CurrentGrapMode = GetButton("1024_768_3")
					If Camera.GrapX = 800 And Camera.GrapY = 600 Then ChangeCurrentGrapModeButton(GetButton("800_600_3"))
					If Camera.GrapX = 1024 And Camera.GrapY = 768 Then ChangeCurrentGrapModeButton(GetButton("1024_768_3"))
					If Camera.GrapX = 1280 And Camera.GrapY = 1024 Then ChangeCurrentGrapModeButton(GetButton("1280_1024_3"))
					
					CurrentFullscreen = Game.ScreenFullscreen
				End If
				If GetButton("About").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					State = 9
				End If
				If GetButton("Quit").Click() Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					Game.StopEngine()
				End If
			Case 9
				If Key.IsMouseHit(1) Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					State = 8
				End If
				
			Case 10
				If GetButton("Cancel2").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,2)
					SetStateToButtons(1,1)
					State = 8
				End If
		
				If GetButton("LoadGame2").Click() And CurrentLoadSaveSlot > 0 Then
					SoundLib.PlaySnd(Sound_Button)
					If Game.IsSaveSlotEmpty("Slot"+CurrentLoadSaveSlot) = 0 Then
						Game.LoadGame("Slot"+CurrentLoadSaveSlot)
						StopMenu()
						TEffectLoadLevel.Create()
						Return
					End If
				End If
				If GetButton("Delete2").Click() And CurrentLoadSaveSlot > 0 Then
					SoundLib.PlaySnd(Sound_Button)
					If Game.IsSaveSlotEmpty("Slot"+CurrentLoadSaveSlot) = 0 Then
						Game.DeleteSaveSlot("Slot"+CurrentLoadSaveSlot)
						GetButton("Slot"+CurrentLoadSaveSlot).Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					End If
				End If

				If GetButton("Slot1").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot = 1
				End If
				If GetButton("Slot2").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot = 2
				End If
				If GetButton("Slot3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot = 3
				End If
				If GetButton("Slot4").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot = 4
				End If
				If GetButton("Slot5").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot = 5
				End If
				
				Select CurrentLoadSaveSlot
				Case 1
					GetButton("Slot1").Creation.SetActive(2)
				Case 2
					GetButton("Slot2").Creation.SetActive(2)
				Case 3
					GetButton("Slot3").Creation.SetActive(2)
				Case 4
					GetButton("Slot4").Creation.SetActive(2)
				Case 5
					GetButton("Slot5").Creation.SetActive(2)
				End Select
				
						
			Case 11
			
				If GetButton("1280_1024_3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					ChangeCurrentGrapModeButton(GetButton("1280_1024_3"))
				End If
				If GetButton("1024_768_3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					ChangeCurrentGrapModeButton(GetButton("1024_768_3"))
				End If
				If GetButton("800_600_3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					ChangeCurrentGrapModeButton(GetButton("800_600_3"))
				End If
				If CurrentGrapMode <> Null Then
					CurrentGrapMode.Creation.SetActive(2)
				End If
				
				If GetButton("Yes_3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentFullscreen = 1
				End If
				If GetButton("No_3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentFullscreen = 0
				End If
				
				If CurrentFullscreen = 1 Then
					GetButton("Yes_3").Creation.SetActive(2)
				Else
					GetButton("No_3").Creation.SetActive(2)
				End If
				
				If GetButton("Apply3").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					Local x#,y#
					If CurrentGrapMode = GetButton("1280_1024_3") Then
						x = 1280
						y = 1024
					End If
					If CurrentGrapMode = GetButton("1024_768_3") Then
						x = 1024
						y = 768
					End If
					If CurrentGrapMode = GetButton("800_600_3") Then
						x = 800
						y = 600
					End If
					Game.ApplyNewSettings(x,y,CurrentFullscreen)
					Return
					
					'SetStateToButtons(2,3)
					'SetStateToButtons(1,1)
					'menu.State = 8
					
				End If
				
				If GetButton("Cancel3").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,3)
					SetStateToButtons(1,1)
					menu.State = 8
				End If
				
			Case 12
				If GetButton("ExitToMenu4").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					For Local eff:TEffect = EachIn Effects
						eff.Free()
					Next
					Effects.Clear()
					WorldManager.EnableLvlChange = 1
					
					StopInGameMenu()
					Game.FreeGame()
					StartMenu()
					RunMenu()
					
					Camera.camera_x = 0
					Camera.camera_y = 0
					Return
				
				End If
				
				If GetButton("BonusShop4").Click() And Player.Creation <> Null Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,4)
					SetStateToButtons(1,8)
					Player.BonusShop.SetEnable(1)
					State = 17
				End If
				
'				If GetButton("SnakeEditor4").Click() Then
'					SetStateToButtons(2,4)
'					SetStateToButtons(1,7)
'					Player.UserSnakeEditor.SetEnable(1)
'					State = 16
'				End If
				
				If GetButton("SaveLoad4").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,4)
					SetStateToButtons(1,5)
					State = 14
					CurrentLoadSaveSlot2 = 0

					
					If Game.IsSaveSlotEmpty("Slot1") = 1 Then
						GetButton("Slot15").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot15").Creation.GetObj().MenuText = GetResImage("Menu_Slot1")
					End If
					If Game.IsSaveSlotEmpty("Slot2") = 1 Then
						GetButton("Slot25").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot25").Creation.GetObj().MenuText = GetResImage("Menu_Slot2")
					End If
					If Game.IsSaveSlotEmpty("Slot3") = 1 Then
						GetButton("Slot35").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot35").Creation.GetObj().MenuText = GetResImage("Menu_Slot3")
					End If
					If Game.IsSaveSlotEmpty("Slot4") = 1 Then
						GetButton("Slot45").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot45").Creation.GetObj().MenuText = GetResImage("Menu_Slot4")
					End If
					If Game.IsSaveSlotEmpty("Slot5") = 1 Then
						GetButton("Slot55").Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					Else
						GetButton("Slot55").Creation.GetObj().MenuText = GetResImage("Menu_Slot5")
					End If
					
				End If
			
				If GetButton("Return4").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,4)
					State = 13
				End If
				
				If GetButton("Quit4").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					Game.StopEngine()
				End If
				
				AnimateValue(Game.PauseGameAlpha,Camera.GlobalAlpha/3,0.02)
				
			Case 13
				AnimateValue(Game.PauseGameAlpha,Camera.GlobalAlpha,0.02)
				Local stop_menu% = 1
				For Local b:TMenuButton = EachIn Buttons
					If b.Group = 4 Then
						If b.Creation.State <> 3 Then
							stop_menu = 0
						End If
					End If
				Next
				If stop_menu = 1 Then
					StopInGameMenu()
				End If
				
			Case 14
				If GetButton("Cancel5").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,5)
					SetStateToButtons(1,4)
					State = 12
				End If
		
				If GetButton("LoadGame5").Click() And CurrentLoadSaveSlot2 > 0 Then
					SoundLib.PlaySnd(Sound_Button)
					If Game.IsSaveSlotEmpty("Slot"+CurrentLoadSaveSlot2) = 0 Then
						Game.LoadGame("Slot"+CurrentLoadSaveSlot2)
						TEffectLoadLevel.Create()
						SetStateToButtons(2,5)
						SetStateToButtons(1,4)
						State = 12
						Return
					End If
				End If
				If GetButton("SaveGame5").Click() And CurrentLoadSaveSlot2 > 0 And Player.Creation <> Null Then
					SoundLib.PlaySnd(Sound_Button)
					Camera.camera_x = camx
					Camera.camera_y = camy
					Game.SaveGame("Slot"+CurrentLoadSaveSlot2)
					SetStateToButtons(2,5)
					SetStateToButtons(1,4)
					State = 12
				End If
				If GetButton("Delete5").Click() And CurrentLoadSaveSlot2 > 0 Then
					SoundLib.PlaySnd(Sound_Button)
					If Game.IsSaveSlotEmpty("Slot"+CurrentLoadSaveSlot2) = 0 Then
						Game.DeleteSaveSlot("Slot"+CurrentLoadSaveSlot2)
						GetButton("Slot"+CurrentLoadSaveSlot2).Creation.GetObj().MenuText = GetResImage("Menu_Empty")
					End If
				End If

				If GetButton("Slot15").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot2 = 1
				End If
				If GetButton("Slot25").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot2 = 2
				End If
				If GetButton("Slot35").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot2 = 3
				End If
				If GetButton("Slot45").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot2 = 4
				End If
				If GetButton("Slot55").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					CurrentLoadSaveSlot2 = 5
				End If
				
				Select CurrentLoadSaveSlot2
				Case 1
					GetButton("Slot15").Creation.SetActive(2)
				Case 2
					GetButton("Slot25").Creation.SetActive(2)
				Case 3
					GetButton("Slot35").Creation.SetActive(2)
				Case 4
					GetButton("Slot45").Creation.SetActive(2)
				Case 5
					GetButton("Slot55").Creation.SetActive(2)
				End Select
				
			Case 15
				'If GetButton("Tutorial6").Click() Then
				'	SoundLib.PlaySnd(Sound_Button)
				'	StopMenu()
				'	Game.CreateGame(100)
				'	Game.VSync = 0
				'	Return
				'End If
				If GetButton("World16").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					StopMenu()
					Game.CreateGame(1)
					Game.VSync = 0
					Return
				End If
				If GetButton("World26").Click() Then
					SoundLib.PlaySnd(Sound_Button)
					StopMenu()
					Game.CreateGame(2)
					Game.VSync = 0
				Return
				End If
				If GetButton("Cancel6").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					SetStateToButtons(2,6)
					SetStateToButtons(1,1)
					menu.State = 8
				End If
				
			'Case 16
			'	Player.UserSnakeEditor.Update()
			'	If GetButton("Cancel7").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
			'		State = 12
			'		Player.UserSnakeEditor.SetEnable(0)
			'		SetStateToButtons(2,7)
			'		SetStateToButtons(1,4)
			'	End If
				
			Case 17
				Player.BonusShop.Update()
				If GetButton("Cancel8").Click() Or Key.IsMouseHit(2) Or Key.IsKeyHit(KEY_ESCAPE) Then
					SoundLib.PlaySnd(Sound_Button)
					State = 12
					Player.BonusShop.SetEnable(0)
					SetStateToButtons(2,8)
					SetStateToButtons(1,4)
				End If
				
			Case 18
				AnimateValue(Game.PauseGameAlpha,Camera.GlobalAlpha/3,0.02)
				
			Case 19
				AnimateValue(Game.PauseGameAlpha,Camera.GlobalAlpha,0.02)
				
				If Game.PauseGameAlpha = Camera.GlobalAlpha Then
					Game.EnableMenuDraw = 0
					Game.EnableMenuUpdate = 0
					Game.PauseGame = 0
					Game.PauseGameAlpha = 1
					'State = 0
					'Return
				End If
											
			Default
		End Select
		
		'FlushMouse()
		FlushMouseKeys()

		Camera.camera_x = camx
		Camera.camera_y = camy
		
	End Method
	
	Method RunMenu()
		State = 5
	End Method
	
	Method Draw()
		Camera.GlobalAlpha = 1
		
		Local camx#,camy#
		camx = Camera.camera_x
		camy = Camera.camera_y
		Camera.camera_x = 0
		Camera.camera_y = 0
		
		Select State
			Case 1,2
				'SetAlpha Alpha
				'SetColor 255,255,255
				'SetScale 1,1
				'SetRotation 0
				'SetBlend ALPHABLEND
				'JgsLogo.DrawResource(Camera.GrapX/2,Camera.GrapY/2)
				'Camera.GlobalAlpha = Alpha
				JgsLogo_Text.Draw(Camera.GrapX/2,Camera.GrapY/2)
				'Camera.GlobalAlpha = 1
			Case 3,4
				'SetBlend ALPHABLEND
				'SetAlpha Alpha
				'SetColor 255,255,255
				'SetScale 1,1
				'SetRotation 0
				'jAquaLogo.DrawResource(Camera.GrapX/2,Camera.GrapY/2)
				'Camera.GlobalAlpha = Alpha
				jAquaLogo_Text.Draw(Camera.GrapX/2,Camera.GrapY/2)
				'Camera.GlobalAlpha = 1
			Case 5,6,7,8,10,11,15
				Camera.GlobalAlpha = Alpha
			Case 9
				SetBlend SOLIDBLEND
				SetAlpha Alpha
				SetScale Camera.GrapX / 800,Camera.GrapY / 600
				SetRotation 0
				SetColor 255,255,255
				'YotsubaFon.DrawResource(Camera.GrapX/2,Camera.GrapY/2)
				AboutLogo.Draw(Camera.GrapX/2,Camera.GrapY/2)
				
			Case 12,13,14
				For Local b:TMenuButton = EachIn Buttons
					If b.Group = 4 Or b.Group = 5 Then
						b.Creation.Draw()
					End If
				Next
				If Player And Player.ScoreManager Then Player.ScoreManager.Update() 'wtf :))))
				
			'Case 16
			'	For Local b:TMenuButton = EachIn Buttons
			'		If b.Group = 4 Or b.Group = 7 Then
			'			b.Creation.Draw()
			'		End If
			'	Next
			'	Player.UserSnakeEditor.Draw()
				
			Case 17
				For Local b:TMenuButton = EachIn Buttons
					If b.Group = 4 Or b.Group = 8 Then
						b.Creation.Draw()
					End If
				Next
				Player.BonusShop.Draw()
				
			Case 18,19
				SetBlend ALPHABLEND
				SetColor 255,255,255
				SetAlpha 1
				SetRotation 0
				SetScale 1,1
			
				PauseImage.DrawResource(Camera.GrapX/2,Camera.GrapY/2)

			Default
		End Select

		Camera.camera_x = camx
		Camera.camera_y = camy
		
	End Method
	
	Field Paused%
	Field PauseImage:TResourceImage
	
	Method SetPause(ps%)
		If ps = Paused Then Return
		If (State < 18 Or State > 19) And Game.EnableMenuUpdate = 1 Then Return
		Paused = ps
		
		If ps = 1 Then
			Game.EnableMenuDraw = 1
			Game.EnableMenuUpdate = 1
			Game.PauseGame = 1
		
			Game.PauseGameAlpha = Camera.GlobalAlpha

			State = 18
		Else
			State = 19
			'Game.EnableMenuDraw = 0
			'Game.EnableMenuUpdate = 0
			'Game.PauseGame = 0
			'Game.PauseGameAlpha = 1
			'State = 0
			'RuntimeError "yeah"
		End If
		
	End Method
	
	Method StartMenu()
		Game.EnableMenuDraw = 1
		Game.EnableMenuUpdate = 1
		'Game.VSync = 1
		State = 0
		
		Camera.camera_x = 0
		Camera.camera_y = 0
		
		If Player <> Null Then
			If Player.Creation <> Null Then
				Creations.Remove(Player.Creation)
			End If
			Player.Free()
			Player = Null
		End If
		TileMap.SetEnableForciblyPosition(1)

	End Method
	Method StopMenu()
		Game.EnableMenuDraw = 0
		Game.EnableMenuUpdate = 0
		TileMap.SetEnableForciblyPosition(0)
	End Method
	
	Method RunInGameMenu()
		Game.EnableMenuDraw = 1
		Game.EnableMenuUpdate = 1
		Game.PauseGame = 1

		SetStateToButtons(4,4)
		SetStateToButtons(4,5)
		For Local b:TMenuButton = EachIn Buttons
			If b.Group = 4 Or b.Group = 5 Then
				b.Creation.Update()
			End If
		Next
		
		Game.PauseGameAlpha = Camera.GlobalAlpha
		
		SetStateToButtons(1,4)

		State = 12
	End Method
	Method StopInGameMenu()

		Game.EnableMenuDraw = 0
		Game.EnableMenuUpdate = 0
		Game.PauseGame = 0
	End Method
	
	Function CreateMenu()
		Menu = New TMenu
		
		
		'Menu.jAquaLogo = GetResImage("jAquaLogo")
		Menu.jAquaLogo_Text = TTextAppear.Create(GetResImage("jAquaLogo"),0,0,0)
		'Menu.JgsLogo = GetResImage("JgsLogo")
		'Menu.YotsubaFon = GetResImage("Menu_AboutImage")
		Menu.JgsLogo_Text = TTextAppear.Create(GetResImage("JgsLogo"),0,0,0)
		
		Menu.PauseImage = GetResImage("Menu_Pause")
		
		Menu.AboutLogo = GetResModel("Menu_AboutModel").CreateModel()
		Menu.AboutLogo.SetAnimation("Main")
		
		GetResAnimImage("Menu_AboutImage").Scale_x = Camera.GrapX / GetResAnimImage("Menu_AboutImage").Fr_x
		GetResAnimImage("Menu_AboutImage").Scale_y = Camera.GrapY / GetResAnimImage("Menu_AboutImage").Fr_y

		
		Menu.Buttons = New TList
		
		Rem
					cx (i = 1) generate X value for menu .. i = 0 - left. i = 1 - central , i = 2 - right
					
					cy ( pos ) generate y value for menu ... pos - position in list... from -1 to 4
		
				End Rem
		
		'group 1 - base menu
		'2 - load\save menu
		'3 - config
		'4 - ingame menu
		'5 - ingame load\save
		
		TMenuButton.Create("jAqua",GetResImage("Menu_jAqua"),cx(),Camera.GrapY/2 - 200,1,5)
		TMenuButton.Create("NewGame",GetResImage("Menu_NewGame"),cx(),cy(0),1)
		TMenuButton.Create("LoadGame",GetResImage("Menu_LoadGame"),cx(),cy(1),1)
		TMenuButton.Create("Config",GetResImage("Menu_Config"),cx(),cy(2),1)
		TMenuButton.Create("About",GetResImage("Menu_About"),cx(),cy(3),1)
		TMenuButton.Create("Quit",GetResImage("Menu_Quit"),cx(),cy(4),1)

		TMenuButton.Create("Slot1",GetResImage("Menu_Slot1"),cx(0),cy(-1),2)
		TMenuButton.Create("Slot2",GetResImage("Menu_Slot2"),cx(0),cy(0),2)
		TMenuButton.Create("Slot3",GetResImage("Menu_Slot3"),cx(0),cy(1),2)
		TMenuButton.Create("Slot4",GetResImage("Menu_Slot4"),cx(0),cy(2),2)
		TMenuButton.Create("Slot5",GetResImage("Menu_Slot5"),cx(0),cy(3),2)
		TMenuButton.Create("LoadGame2",GetResImage("Menu_LoadGame"),cx(2),cy(2),2)
		TMenuButton.Create("Delete2",GetResImage("Menu_Delete"),cx(2),cy(3),2)
		TMenuButton.Create("Cancel2",GetResImage("Menu_Cancel"),cx(2),cy(4),2)
		
		Menu.GrapSlot1x = cx(0)
		Menu.GrapSlot1y = cy(0)
		Menu.GrapSlot2x = cx(1)
		Menu.GrapSlot2y = cy(1)
		Menu.GrapSlot3x = cx(2)
		Menu.GrapSlot3y = cy(0)

		TMenuButton.Create("1280_1024_3",GetResImage("Menu_1280_1024"),Menu.GrapSlot1x,Menu.GrapSlot1y,3)
		TMenuButton.Create("1024_768_3",GetResImage("Menu_1024_768"),Menu.GrapSlot2x,Menu.GrapSlot2y,3)
		TMenuButton.Create("800_600_3",GetResImage("Menu_800_600"),Menu.GrapSlot3x,Menu.GrapSlot3y,3)
		TMenuButton.Create("FullScreen_3",GetResImage("Menu_FullScreen"),cx(0),cy(3),3)
		TMenuButton.Create("Yes_3",GetResImage("Menu_Yes"),cx(1),cy(3),3)
		TMenuButton.Create("No_3",GetResImage("Menu_No"),cx(2),cy(3),3)
		TMenuButton.Create("Apply3",GetResImage("Menu_Apply"),cx(1),cy(4),3)
		TMenuButton.Create("Cancel3",GetResImage("Menu_Cancel"),cx(2),cy(4),3)

		TMenuButton.Create("SaveLoad4",GetResImage("Menu_SaveLoad"),cx(2),cy(0),4)
		'TMenuButton.Create("SnakeEditor4",GetResImage("Menu_SnakeEditor"),cx(2),cy(0),4)
		TMenuButton.Create("BonusShop4",GetResImage("Menu_BonusShop"),cx(2),cy(1),4)
		TMenuButton.Create("Return4",GetResImage("Menu_ReturnToGame"),cx(2),cy(2),4)
		TMenuButton.Create("ExitToMenu4",GetResImage("Menu_ExitToMenu"),cx(3),cy(3),4)
		TMenuButton.Create("Quit4",GetResImage("Menu_Quit"),cx(2),cy(4),4)
		
		TMenuButton.Create("Slot15",GetResImage("Menu_Slot1"),cx(0),cy(-1),5)
		TMenuButton.Create("Slot25",GetResImage("Menu_Slot2"),cx(0),cy(0),5)
		TMenuButton.Create("Slot35",GetResImage("Menu_Slot3"),cx(0),cy(1),5)
		TMenuButton.Create("Slot45",GetResImage("Menu_Slot4"),cx(0),cy(2),5)
		TMenuButton.Create("Slot55",GetResImage("Menu_Slot5"),cx(0),cy(3),5)
		TMenuButton.Create("SaveGame5",GetResImage("Menu_SaveGame"),cx(2),cy(1),5)
		TMenuButton.Create("LoadGame5",GetResImage("Menu_LoadGame"),cx(2),cy(2),5)
		TMenuButton.Create("Delete5",GetResImage("Menu_Delete"),cx(2),cy(3),5)
		TMenuButton.Create("Cancel5",GetResImage("Menu_Cancel"),cx(2),cy(4),5)
		
		'TMenuButton.Create("Tutorial6",GetResImage("Menu_Tutorial"),cx(),cy(0),6)
		TMenuButton.Create("World16",GetResImage("Menu_World1"),cx(),cy(1),6)
		TMenuButton.Create("World26",GetResImage("Menu_World2"),cx(),cy(2),6)
		TMenuButton.Create("Cancel6",GetResImage("Menu_Cancel"),cx(2),cy(4),6)

		TMenuButton.Create("Cancel7",GetResImage("Menu_Cancel"),cx(2),cy(4),7)

		TMenuButton.Create("Cancel8",GetResImage("Menu_Cancel"),cx(2),cy(4),8)

		Menu.State = 0
		Menu.LastTime = MilliSecs()

		Game.VSync = 1
	End Function
	
End Type

Function cx#(i% = 1)
	Local cx# = Camera.GrapX/2
	Local a1#,a2#
	If i = 0 Then
		a1 = -300
		a2 = -200
	End If
	If i = 1 Then
		a1 = -100
		a2 = 100
	End If
	If i = 2 Then
		a1 = 150
		a2 = 250
	End If
	Return cx+Rand(a1,a2)
End Function
Function cy#(i%)
	Local cy# = Camera.GrapY/2
	Local s# = 130
	Local z# = 90
	Return cy-s+z*i
End Function
