'base type for all resources

Type TResource
	Field Name$
	Field ResType$
	Field LockFree%

	Method Free%() Abstract

	Field LastUse%
	Field EnableUnLoading%
	Field BlockUnLoad% = 0
	Field UnLoad% = 0
	Field T_Str:TStream
	
	Method CheckUnload()
		If EnableUnLoading = 0 Or BlockUnLoad = 1 Then
			If T_Str <> Null Then
				T_Str.Close()
			End If
			T_Str = Null
			Return
		End If
		If UnLoad = 1 Then Return

		If EnableUnLoading = 1 And ((jMillisecs() - LastUse) > 5000) Then
			WorkUnLoad()
			UnLoad = 1
		End If
	End Method
	
	Method LoadChecks()
		LastUse = jMillisecs()
		If UnLoad = 1 Then
			WorkLoad()
			UnLoad = 0
		End If
	End Method
	
	Field DeltaLoadTime#
	Method LoadingCacheResource(st%=0) 'if 0 - start, if 1 - end
		Select st
		Case 0
			DeltaLoadTime = jMillisecs()
		Case 1
			If jMillisecs() - DeltaLoadTime > 100 Then
				BlockUnLoad = 1
			End If
		End Select
	End Method
	
	Method WorkUnLoad() Abstract
	Method WorkLoad() Abstract
	
End Type
