'animation image resource

Type TResourceAnimImage Extends TResource
	Field iImage:TImage
	Field File_Name$
	Field CellCount%
	Field DrawFlags%
	Field StartCell%
	Field Scale_x#,Scale_y#
	
	Field ImageFileName$
	
	Field Fr_x#,Fr_y#
	Field Fr_cx#,Fr_cy#
	Field Fr_stc%

	Method DrawAnimResource(x#,y#,enable_states% = 1,frame% = 0)
		If frame >= StartCell And frame <= CellCount Then
			LoadChecks()
			If enable_states Then
				SetScale Scale_x#,Scale_y#
				SetBlend DrawFlags%
			End If
			DrawImg(iImage,x,y,frame)
		End If
	End Method
	
	Method Image:TImage()
		LoadChecks()
		Return iImage
	End Method

	Method Free()
		If LockFree% = 0 Then
			iImage = Null
			If T_Str <> Null Then
				T_Str.Close()
				T_Str = Null
			End If
		End If
	End Method
	
	Method WorkUnLoad()
		iImage = Null
	End Method
	Method WorkLoad()
		If iImage = Null Then
			If T_Str = Null Then T_Str = ReadPakFile(ImageFileName)
			T_Str.Seek(0)
		
			LoadingCacheResource()
			iImage = LoadAnimImage(T_Str,Fr_x,Fr_y,StartCell,CellCount)
			LoadingCacheResource(1)
		
			Assert iImage,"Filed to load dynamicly image resource : "+name$+" file : "+File_Name$
			
			If Fr_stc = 1 Then
				SetImageHandle iImage,Fr_cx,Fr_cy
			End If
		End If
	End Method
	
	Function LoadResource:TResourceAnimImage(file_name$,name$)
		Local Res:TResourceAnimImage = New TResourceAnimImage
		Local file:TStream = ReadPakFile(file_name)
		
		Local header$ = ReadString(file,5)
		If header<>"j2img" Then RuntimeError "Image format corrupt"
		
		Local version% = ReadInt(file)
		If version<>1 Then RuntimeError "Image file version doesnt support"
		
		Local image_file_name$ = ExtractDir$(file_name) + "/" + ReadLine(file)
		Res.ImageFileName = image_file_name
		Local frame_x% = ReadInt(file)
		Local frame_y% = ReadInt(file)
		Local frame_center_x% = ReadInt(file)
		Local frame_center_y% = ReadInt(file)
		Res.Scale_x = ReadFloat(file)
		Res.Scale_y = ReadFloat(file)
		Res.DrawFlags = ReadInt(file)
		Res.StartCell = ReadInt(file)
		Res.CellCount = ReadInt(file)
		
		Local header_end$ = ReadString(file,7)

		Res.T_Str = ReadPakFile(image_file_name)
		
		If ResourceManager.NullLoading = 1 Then
			Res.UnLoad = 1
			Res.iImage = Null
		Else
			Res.LoadingCacheResource()
			Res.iImage = LoadAnimImage(Res.T_Str,frame_x,frame_y,Res.StartCell,Res.CellCount)
			Res.LoadingCacheResource(1)
		
			Assert Res.iImage,"Filed to load image resource : "+name$+" file : "+file_name$
			SetImageHandle Res.iImage,frame_center_x,frame_center_y
		End If
		
		Res.Fr_x = frame_x
		Res.Fr_y = frame_y
		Res.Fr_cx = frame_center_x
		Res.Fr_cy = frame_center_y
		Res.Fr_stc = 1
		
		Res.Name = name
		Res.File_Name = file_name
		Res.ResType$ = "AnimImage"
		
		Return Res
	End Function
End Type


Function GetResAnimImage:TResourceAnimImage(name$)
	Return TResourceAnimImage(ResourceManager.GetResource(name))
End Function

Function NewAnimImageRes(file$,resname$)
	ResourceManager.CreateNewRes(TResource(TResourceAnimImage.LoadResource(File,ResName)))
End Function

Function NewAnimImageResBmax(file$,resname$,frx#,fry#,frs%,frc%,fl% = 1)
	Local Res:TResourceAnimImage = New TResourceAnimImage

	Res.Fr_x = frx
	Res.Fr_y = fry
	Res.StartCell = frs
	Res.CellCount = frc
	Res.Fr_cx = frx/2
	Res.Fr_cy = fry/2
	Res.Fr_stc = fl
	Res.T_Str = ReadPakFile(file)
	Res.Scale_x = 1
	Res.Scale_y = 1
	Res.DrawFlags = 3
	
	Res.iImage = LoadAnimImage(Res.T_Str,frx,fry,frs,frc)
	Assert Res.iImage,"Filed to load image resource : "+resname$+" file : "+file$

	If fl = 1 Then
		SetImageHandle Res.iImage,frx/2,fry/2
	End If

	Res.Name = resname
	Res.ResType$ = "AnimImage"

	ResourceManager.CreateNewRes(TResource(Res))
End Function

Function NewAnimImageResBmax2(file$,resname$)
	Local Res:TResourceAnimImage = New TResourceAnimImage

	Res.T_Str = ReadPakFile(file)
	
	Local img:TImage = LoadImage(Res.T_Str)
	Res.T_Str.Seek(0)
	
	Res.Fr_x = img.width
	Res.Fr_y = img.height
	Res.StartCell = 0
	Res.CellCount = 1
	Res.Fr_cx = Res.Fr_x/2
	Res.Fr_cy = Res.Fr_y/2
	Res.Fr_stc = 1
	Res.Scale_x = 1
	Res.Scale_y = 1
	Res.DrawFlags = 3

	img = Null
	
	Res.iImage = LoadAnimImage(Res.T_Str,Res.Fr_x,Res.Fr_y,Res.StartCell,Res.CellCount)
	Assert Res.iImage,"Filed to load image resource : "+resname$+" file : "+file$

	If Res.Fr_stc = 1 Then
		SetImageHandle Res.iImage,Res.Fr_x/2,Res.Fr_y/2
	End If

	Res.Name = resname
	Res.ResType$ = "AnimImage"

	ResourceManager.CreateNewRes(TResource(Res))
End Function

