'jimon resource manager

Include "TResource.bmx"
Include "TResourceImage.bmx"
Include "TResourceAnimImage.bmx"
Include "TResourceModel.bmx"
Include "TResourceSound.bmx"

Global ResourceManager:TResourceManager

Type TResourceManager
	Field Resources:TList
	'Field Resources:TMap

	'----------------------------------------------------------------
	'simply cache, need to rewrite
	Field LastName$ = Null
	Field LastResource:TResource = Null
	Method CheckCache%(name$)
		If LastName = name Then
			Return 1
		Else
			LastName = name
			Return 0
		End If
	End Method
	Method GetCache:TResource()
		Return LastResource
	End Method
	Method ClearCache()
		LastResource = Null
	End Method
	Method SetInCache(Res:TResource)
		LastResource = Res
	End Method
	'----------------------------------------------------------------

	Method FreeResources()
		UnLockResources()
		For Local res:TResource = EachIn Resources
			res.Free()
		Next
		
		ClearCache()
		Resources.Clear()
		Resources = Null
		ResourceManager = Null
	End Method
	
	Method GetResource:TResource(name$)
		If CheckCache(name) = 1 Then Return GetCache()

		For Local p:TResource = EachIn Resources
			If p.Name = name Then
				SetInCache(p)
				Return p
			End If
		Next
		
		'for tmap
		'Local p:TResource = TResource(Resources.ValueForKey(name))
		'SetInCache(p)
		'Return p
		
	End Method
	
	Field CreateWithUnload% = 1
	Field NullLoading% = 1

	Method CreateNewRes(res:TResource)
		If LockRes = 1 Then Return

		Resources.AddLast res
		
		'Resources.Insert(res.Name,res) 'also new tmap style
		
		Res.EnableUnLoading = CreateWithUnload

		If Gui <> Null Then Gui.LoadingBar()
	End Method
	
	Method GetLastRes:TResource()
		Return TResource(Resources.Last())
		
		'Return TResource(Resources._LastNode().Value())
	End Method
	
	Method DebugUnLoads$()
		Local loaded%,unloaded%,bl%
		For Local p:TResource = EachIn Resources
			If p.BlockUnLoad = 1 Then bl:+1
			If p.UnLoad = 1 Then
				unloaded:+1
			Else
				loaded:+1
			End If
		Next
		
		If bl > 0 Then
			Return "Loaded : "+loaded+" Unloaded : "+unloaded+" Blocked : "+bl
		Else
			Return "Loaded : "+loaded+" Unloaded : "+unloaded
		End If
	End Method
	
	Method Update()
		If Game.ReleaseVersion = 0 Then
			GCCollect()
		End If
		
		For Local p:TResource = EachIn Resources
			p.CheckUnload()
		Next
	End Method
	
	Method Restart() 'full resource manager restart
		For Local p:TResource = EachIn Resources
			p.WorkUnLoad()
			p.WorkLoad()
		Next
	End Method
	
	Method LoadCoreResources() 'for gui
		'NewImageRes("Media/Textures/terrain_main.png","TileMap_Main")
		NewImageRes("Media/Textures/Texts/please_wait_loading.png","Menu_PleaseWaitLoading")
		NewAnimImageResBmax("Media/Textures/progressbar_front.png","ProgressBar_Front",2,12,0,2,0)
		NewAnimImageResBmax("Media/Textures/progressbar_back.png","ProgressBar_Back",4,4,0,18,0)
	End Method
	Method LoadGameResources() 'for game
		'>>>>>>>>>>>>>>>>>>>>> Sounds
		NewSoundRes("Media/Sound/Music/01.ogg", "Music_01") 
		NewSoundRes("Media/Sound/Music/02.ogg", "Music_02") 
		NewSoundRes("Media/Sound/Music/03.ogg", "Music_03") 

		NewSoundRes("Media/Sound/Sounds/01.ogg", "Sound_01") 
		NewSoundRes("Media/Sound/Sounds/02.ogg", "Sound_02") 
		NewSoundRes("Media/Sound/Sounds/03.ogg", "Sound_03") 
		NewSoundRes("Media/Sound/Sounds/04.ogg", "Sound_04") 
		NewSoundRes("Media/Sound/Sounds/05.ogg", "Sound_05") 
		NewSoundRes("Media/Sound/Sounds/06.ogg", "Sound_06") 
		NewSoundRes("Media/Sound/Sounds/07.ogg", "Sound_07") 
		NewSoundRes("Media/Sound/Sounds/08.ogg", "Sound_08") 
		NewSoundRes("Media/Sound/Sounds/09.ogg", "Sound_09") 
		NewSoundRes("Media/Sound/Sounds/10.ogg", "Sound_10") 
	
		'>>>>>>>>>>>>>>>>>>>>>Simple Images
		NewImageRes("Media/Textures/fx_explosion.png","Fx_Explosion")
		'NewImageRes("Media/Textures/fx_cubics.png","Fx_Cubics")
		For Local i% = 1 To 24
			NewImageRes("Media/Textures/Texts/levels/level"+i+".png","Gui_Level"+i)
		Next
		NewImageRes("Media/Textures/Texts/levels/tutorial_title.png","Gui_Tutorial_Title")
		NewImageRes("Media/Textures/Texts/levels/world1_title.png","Gui_World1_Title")
		NewImageRes("Media/Textures/Texts/levels/world2_title.png","Gui_World2_Title")
		NewImageRes("Media/Textures/fxtilemap.png","Fx_TileMap")
		NewImageRes("Media/Textures/Walls/wall1.png","Fx_WallMap1")
		NewImageRes("Media/Textures/Walls/wall2.png","Fx_WallMap2")
		NewImageRes("Media/Textures/Walls/wall3.png","Fx_WallMap3")
		NewImageRes("Media/Textures/Walls/wall4.png","Fx_WallMap4")
		NewImageRes("Media/Textures/Cursor1.png","Cursor1")
		NewImageRes("Media/Textures/Cursor2.png","Cursor2")
		NewImageRes("Media/Textures/Cursor3.png","Cursor3")
		NewImageRes("Media/Textures/strelka.png","Unit_Strelka")
		NewImageRes("Media/Textures/r1.png","UserScore_Ring1")
		NewImageRes("Media/Textures/r2.png","UserScore_Ring2")
		NewImageRes("Media/Textures/r3.png","UserScore_Ring3")
		NewImageRes("Media/Textures/r4.png","UserScore_Ring4")
		NewImageRes("Media/Textures/r5.png","UserScore_Ring5")
		'NewImageRes("Media/Textures/Portal/portal_0.png","PortalLayer_0")
		NewImageRes("Media/Textures/Portal/portal_1.png","PortalLayer_1")
		NewImageRes("Media/Textures/Portal/portal_2.png","PortalLayer_2")
		NewImageRes("Media/Textures/Portal/portal_3.png","PortalLayer_3")
		NewImageRes("Media/Textures/Portal/portal_4.png","PortalLayer_4")
		NewImageRes("Media/Textures/Portal/portal_5.png","PortalLayer_5")
		NewImageRes("Media/Textures/Portal/portal_6.png","PortalLayer_6")
		NewImageRes("Media/Textures/Portal/portal_7.png","PortalLayer_7")
		NewImageRes("Media/Textures/ui2_circle.png","Navigator_Cirlce")
		NewImageRes("Media/Textures/ui2_line1.png","Navigator_Line1")
		NewImageRes("Media/Textures/ui2_line2.png","Navigator_Line2")
		NewImageRes("Media/Textures/ui2_line3.png","Navigator_Line3")
		NewAnimImageResBmax("Media/Textures/font1.png","Font_1",32,32,0,10)
		NewImageRes("Media/Textures/ministar.png","UserScore_MiniStar")
		
		'>>>>>>>>>>>>>>>>>>> World 1
		NewImageRes("Media/Textures/Texts/caninjury.png","World1_CanInjury")
		NewImageRes("Media/Textures/Texts/peacefulcreation.png","World1_PeacefulCreation")
		NewImageRes("Media/Textures/Texts/peacefulsnake.png","World1_PeacefulSnake")
		
		'>>>>>>>>>>>>>>>>>>> Jimon Images
		NewAnimImageRes("Media/Creations/Snake/Head/Snake_Head.ji","Snake_Head")
		NewAnimImageRes("Media/Creations/Snake/LiveSphere/LiveSphere.ji","LiveSphere")
		NewAnimImageRes("Media/Creations/Snake/Add/Add.ji","Add_Image")
		NewAnimImageRes("Media/Creations/Snake/Tail/Tail.ji","Tail")
		NewAnimImageRes("Media/Creations/Snake/Spheres/Sphere_1.ji","Sphere_1")
		NewAnimImageRes("Media/Creations/Snake/Spheres/Sphere_2.ji","Sphere_2")
		NewAnimImageRes("Media/Creations/Snake/Spheres/Sphere_3.ji","Sphere_3")
		NewAnimImageRes("Media/Creations/Snake/Spheres/Sphere_4.ji","Sphere_4")
		NewAnimImageRes("Media/Creations/Snake/Spheres/Sphere_5.ji","Sphere_5")
		NewAnimImageRes("Media/Creations/Snake/Wings/Wings.ji","Wings")
		NewAnimImageRes("Media/Creations/Snail/Snail.ji","Snail_Image")
		NewAnimImageRes("Media/Creations/Singles/Single/Single.ji","Single_Image")
		NewAnimImageRes("Media/Creations/Singles/Single2/Single2.ji","Single2_Image")
		NewAnimImageRes("Media/Creations/Singles/Single3/Single3.ji","Single3_Image")
		NewAnimImageRes("Media/Creations/Singles/Single4/Single4.ji","Single4_Image")
		NewAnimImageRes("Media/Creations/Singles/Single5/Single5.ji","Single5_Image")
		NewAnimImageRes("Media/Creations/Virus/Virus_Body1.ji","Virus_Body1_Image")
		NewAnimImageRes("Media/Creations/Virus/Virus_Jgut1.ji","Virus_Jgut1_Image")
		NewAnimImageRes("Media/Creations/Virus/Virus_Jgut2.ji","Virus_Jgut2_Image")
		NewAnimImageRes("Media/Creations/JellyFish/JellyFish_Head.ji","JellyFish_Head_Image")
		NewAnimImageRes("Media/Creations/JellyFish/JellyFish_Body.ji","JellyFish_Body_Image")
		NewAnimImageRes("Media/Creations/Star/Star_01.ji","Star_01_Image")
		NewAnimImageRes("Media/Creations/Star/Star_02.ji","Star_02_Image")
		NewAnimImageRes("Media/Creations/Star/Star_03.ji","Star_03_Image")
		NewAnimImageRes("Media/Creations/Star/Star_04.ji","Star_04_Image")
		NewAnimImageRes("Media/Creations/Shell/Shell_01.ji","Shell_01_Image")
		NewAnimImageRes("Media/Creations/Seaweed/Seaweed.ji","Seaweed_Image")
		NewAnimImageRes("Media/Bonus/Bonus_01/Bonus_01.ji","Bonus_01_Image")
		NewAnimImageRes("Media/Bonus/Bonus_02/Bonus_02.ji","Bonus_02_Image")
		NewAnimImageRes("Media/Bonus/Bonus_03/Bonus_03.ji","Bonus_03_Image")
		NewAnimImageRes("Media/Bonus/Bonus_04/Bonus_04.ji","Bonus_04_Image")
		NewAnimImageRes("Media/Bonus/Bonus_05/Bonus_05.ji","Bonus_05_Image")
		NewAnimImageRes("Media/Bonus/Bonus_06/Bonus_06.ji","Bonus_06_Image")
		NewAnimImageRes("Media/Bonus/Bonus_07/Bonus_07.ji","Bonus_07_Image")
		NewAnimImageRes("Media/Creations/DNAVirus/DNAVirus.ji","DNAVirus_Image")

		'>>>>>>>>>>>>>>>>>>>>>>>> Jimon Models
		NewModelRes("Media/Creations/Snake/Head/Snake_Head.jm","Snake_Head_Model")
		NewModelRes("Media/Creations/Snake/Add/Add.jm","Add_Model")
		NewModelRes("Media/Creations/Snake/Tail/Tail.jm","Tail_Model")
		NewModelRes("Media/Creations/Snake/Snake_Object.jm","Snake_Object_Model")
		NewModelRes("Media/Creations/Snail/Snail.jm","Snail_Model")
		NewModelRes("Media/Creations/Singles/Single/Single.jm","Single_Model")
		NewModelRes("Media/Creations/Singles/Single2/Single2.jm","Single2_Model")
		NewModelRes("Media/Creations/Singles/Single3/Single3.jm","Single3_Model")
		NewModelRes("Media/Creations/Singles/Single4/Single4.jm","Single4_Model")
		NewModelRes("Media/Creations/Singles/Single5/Single5.jm","Single5_Model")
		NewModelRes("Media/Creations/Virus/Virus.jm","Virus_Model")
		NewModelRes("Media/Creations/JellyFish/JellyFish.jm","JellyFish_Model")
		NewModelRes("Media/Creations/Star/Star.jm","Star_Model")
		NewModelRes("Media/Creations/Shell/Shell.jm","Shell_Model")
		NewModelRes("Media/Creations/Seaweed/Seaweed.jm","Seaweed_Model")
		NewModelRes("Media/Bonus/Bonus_Model.jm","Bonus_Model")
		NewModelRes("Media/Creations/DNAVirus/DNAVirus.jm","DNAVirus_Model")

		
	End Method
	Method LoadMenuResources() 'for menu
		NewImageRes("Media/Textures/jgs_logo.png","JgsLogo")
		NewImageRes("Media/Textures/JgsLogo_BlurV80.png","JgsLogo_BlurV80")
		NewImageRes("Media/Textures/JgsLogo_BlurV70.png","JgsLogo_BlurV70")
		NewImageRes("Media/Textures/JgsLogo_BlurV60.png","JgsLogo_BlurV60")
		NewImageRes("Media/Textures/jAqua_logo.png","jAquaLogo")
		NewImageRes("Media/Textures/jAquaLogo_BlurV80.png","jAquaLogo_BlurV80")
		NewImageRes("Media/Textures/jAquaLogo_BlurV70.png","jAquaLogo_BlurV70")
		NewImageRes("Media/Textures/jAquaLogo_BlurV60.png","jAquaLogo_BlurV60")
		NewImageRes("Media/Textures/jAqua.png","Menu_jAqua")
		NewAnimImageRes("Media/Textures/About/Image.ji","Menu_AboutImage")
		NewModelRes("Media/Textures/About/Image.jm","Menu_AboutModel")
		
		'texts
		NewImageRes("Media/Textures/Texts/NewGame.png","Menu_NewGame")
		NewImageRes("Media/Textures/Texts/Quit.png","Menu_Quit")
		NewImageRes("Media/Textures/Texts/LoadGame.png","Menu_LoadGame")
		NewImageRes("Media/Textures/Texts/SaveGame.png","Menu_SaveGame")
		NewImageRes("Media/Textures/Texts/ExitToMenu.png","Menu_ExitToMenu")
		NewImageRes("Media/Textures/Texts/Config.png","Menu_Config")
		NewImageRes("Media/Textures/Texts/About.png","Menu_About")
		NewImageRes("Media/Textures/Texts/1024_768.png","Menu_1024_768")
		NewImageRes("Media/Textures/Texts/1280_1024.png","Menu_1280_1024")
		NewImageRes("Media/Textures/Texts/800_600.png","Menu_800_600")
		NewImageRes("Media/Textures/Texts/FullScreen.png","Menu_FullScreen")
		NewImageRes("Media/Textures/Texts/No.png","Menu_No")
		NewImageRes("Media/Textures/Texts/Slot1.png","Menu_Slot1")
		NewImageRes("Media/Textures/Texts/Slot2.png","Menu_Slot2")
		NewImageRes("Media/Textures/Texts/Slot3.png","Menu_Slot3")
		NewImageRes("Media/Textures/Texts/Slot4.png","Menu_Slot4")
		NewImageRes("Media/Textures/Texts/Slot5.png","Menu_Slot5")
		NewImageRes("Media/Textures/Texts/Yes.png","Menu_Yes")
		NewImageRes("Media/Textures/Texts/apply.png","Menu_Apply")
		NewImageRes("Media/Textures/Texts/cancel.png","Menu_Cancel")
		NewImageRes("Media/Textures/Texts/save_load.png","Menu_SaveLoad")
		NewImageRes("Media/Textures/Texts/return_to_game.png","Menu_ReturnToGame")
		NewImageRes("Media/Textures/Texts/empty.png","Menu_Empty")
		NewImageRes("Media/Textures/Texts/delete.png","Menu_Delete")
		NewImageRes("Media/Textures/Texts/World1.png","Menu_World1")
		NewImageRes("Media/Textures/Texts/World2.png","Menu_World2")
		NewImageRes("Media/Textures/Texts/Tutorial.png","Menu_Tutorial")
		NewImageRes("Media/Textures/Texts/gameover.png","Menu_GameOver")
		NewImageRes("Media/Textures/Texts/BonusShop.png","Menu_BonusShop")
		NewImageRes("Media/Textures/Texts/SnakeEditor.png","Menu_SnakeEditor")
		NewImageRes("Media/Textures/Texts/Buy.png","Menu_Buy")
		NewImageRes("Media/Textures/Texts/Sell.png","Menu_Sell")
		NewImageRes("Media/Textures/Texts/Activate.png","Menu_Activate")
		NewImageRes("Media/Textures/Texts/Deactivate.png","Menu_Deactivate")
		NewImageRes("Media/Textures/Texts/full_stuff.png","Menu_FullStuff")
		NewAnimImageResBmax2("Media/Textures/Texts/Stuff.png","Menu_Stuff")
		NewAnimImageResBmax2("Media/Textures/Texts/Store.png","Menu_Store")
		NewImageRes("Media/Textures/Texts/Money.png","Menu_Money")
		NewImageRes("Media/Textures/Texts/SpeedBonus.png","Info_SpeedBonus")
		NewImageRes("Media/Textures/Texts/LifeBonus.png","Info_LifeBonus")
		NewImageRes("Media/Textures/Texts/DoubleLifeBonus.png","Info_DoubleLifeBonus")
		NewImageRes("Media/Textures/Texts/AntidoteBonus.png","Info_AntidoteBonus")
		NewImageRes("Media/Textures/Texts/FirstAidKit.png","Info_FirstAidKit")
		NewImageRes("Media/Textures/Texts/WingsBonus.png","Info_WingsBonus")
		NewImageRes("Media/Textures/Texts/Pause.png","Menu_Pause")
		NewImageRes("Media/Textures/Texts/Presents.png","Menu_Presents")
		
	End Method
	
	Method LoadEditorResources()
		NewImageRes("Media/Editor/tilemap.png","Edit_Map")
	End Method
	
	Field LockRes% = 0
	Method LockResources()
		For Local res:TResource = EachIn Resources
			res.LockFree = 1
		Next
		LockRes = 1
		
		For Local res:TResource = EachIn Resources
			res.LastUse = jMillisecs()
		Next
	End Method
	Method UnLockResources()
		For Local res:TResource = EachIn Resources
			res.LockFree = 0
		Next
		LockRes = 0
	End Method
	
	Function CreateResourceManager()
		 ResourceManager = New TResourceManager
		 ResourceManager.Resources = New TList
		 'ResourceManager.Resources = New TMap
	End Function

End Type




