

Type TScriptCreationInfo Extends TScript
	Field ResName$
	Field Eff:TEffect

	Method OnEvent(ScriptEventData:TScriptEventData)
		If Not ScriptEventData Then Return
		
		Select ScriptEventData.EventName
		Case TScriptEventData.OnDie
			ScriptEventData.Creation.Scripts.Remove(Self)
			Free()
			Return
		Default
		End Select
	End Method
	
	Method Free()
		Creation = Null
		
		If Eff <> Null Then
			Eff.Free()
			Eff = Null
		End If
	End Method
	
	Method Update()
		If Eff = Null Then
			Eff = TEffectComputerGui.Create(Creation,GetResImage(ResName))
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method AddCollisionRequest()
	End Method
	
	Method SerealizeScript()
		SerLine(ResName)
	End Method
	
	Function Create:TScript(name$)
		Local sc:TScriptCreationInfo = New TScriptCreationInfo
		sc.ScriptType = "CreationInfo"
		sc.ResName = name
		Return sc
	End Function
End Type

