
Type TScriptDropCreation Extends TScript
	Field CreationType$
	Field CreationParam%
	
	Field DropMethod% '1 - on timer, 2 - on die, 3 - 1&2
	
	Field DeltaTimer#
	Field LastTimer#
	
	Method CreateCreation%()
		Local cr:TCreation
		cr = WorldManager.CreateFullCreationFromType(CreationType,CreationParam,CreationParam,CreationParam)
		If cr <> Null Then
			Return WorldManager.AddCreationToWorld(cr)
		Else
			RuntimeError "DropCreation script : "+CreationType+" / "+CreationParam
		End If
	End Method
	
	Method OnEvent(ScriptEventData:TScriptEventData)
		If Not ScriptEventData Then Return
		If DropMethod < 2 Then Return
		Select ScriptEventData.EventName
		Case TScriptEventData.OnDie
			Local ok% = CreateCreation()
			If ok = 1 Then
				TCreation(Creations.Last()).SetPosition(Creation.gco(0).x,Creation.gco(0).y)
				ScriptEventData.Creation.Scripts.Remove(Self)
				Free()
				Return
			End If
		Default
		End Select
	End Method
	
	Method Free()
		Creation = Null
	End Method
	
	Method Update()
		If DropMethod <> 2 Then
			If (jMilliSecs() - LastTimer) > DeltaTimer Then
				LastTimer = jMilliSecs()
				CreateCreation()
				TCreation(Creations.Last()).SetPosition(Creation.gco(0).x,Creation.gco(0).y)
			End If
		End If
	End Method
	
	Method Draw()
	End Method
	
	Method AddCollisionRequest()
	End Method
	
	Method SerealizeScript()
		SerInt(DropMethod)
		SerLine(CreationType)
		SerInt(CreationParam)
		SerFloat(DeltaTimer)
	End Method
	
	Function Create:TScript(DropMethod%,CreationType$,CreationParam% = -9999,DeltaTimer# = 0)
		Local sc:TScriptDropCreation = New TScriptDropCreation
		sc.ScriptType = "DropCreation"
		
		sc.DropMethod = DropMethod
		sc.CreationType = CreationType
		sc.CreationParam = CreationParam
		sc.DeltaTimer = DeltaTimer
		
		Return sc
	End Function
	
End Type

