'tile map type

Function jTileImage( image:TImage,x#=0,y#=0,frame%=0 )
	Local iframe:TImageFrame=image.Frame(frame)
	If Not iframe Return
	
	Local scx#,scy#
	GetScale(scx,scy)
	
	Local w# = image.width * scx
	Local h# = image.height * scy
	
	Local ox#,oy#,vw%,vh%,vox%,voy%
	GetViewport (vox,voy,vw,vh)
	ox = vox - w + 1
	oy = voy - h + 1
	
	Local px#,py#
	GetOrigin(px,py)
	
	px = x + px - image.handle_x * scx
	py = y + py - image.handle_y * scy
	
	Local fx# = px - Floor(px)
	Local fy# = py - Floor(py)
	Local tx# = Floor(px) - ox
	Local ty# = Floor(py) - oy

	If tx>=0 tx=tx Mod w + ox Else tx=w - -tx Mod w + ox
	If ty>=0 ty=ty Mod h + oy Else ty=h - -ty Mod h + oy

	Local vr# = vox + vw + w
	Local vb# = voy + vh + h

	Local iy# = ty
	While iy <= vb
		Local ix# = tx
		While ix <= vr
			iframe.Draw 0,0,image.width,image.height,ix+fx,iy+fy
			ix = ix + w
		Wend
		iy = iy + h
	Wend

End Function

Type TTileMap
	Field TileMapImage:TResourceImage
	Field TileMapFx:TResourceImage
	Field WallMap1:TResourceImage
	Field WallMap2:TResourceImage
	Field WallMap3:TResourceImage
	Field WallMap4:TResourceImage
	
	Field EnableForciblyPosition% = 0
	Field PositionX#,PositionY#

	Field MapPosX#,MapPosY#
	
	Field EffectEnable%
	Field AnimTimer%

	Field DrawableMax% = 10
	
	Field BGR#,BGG#,BGB#
	Field BGNeedR#,BGNeedG#,BGNeedB#
	
	Field BackGroundColorMode% = 0 '0 - def,1 - opt1
	
	Field DrawLines% = 0
	Field Edit_Map:TResourceImage
	

	Method Free()
		TileMapImage = Null
		TileMapFx = Null
		WallMap1 = Null
		WallMap2 = Null
		WallMap3 = Null
		WallMap4 = Null
		
		Edit_Map = Null
	End Method
	
	Method AnimateValueTileMap%(in# Var,ch#,speed#)
		If Abs(ch - in) <= speed Then
			in = ch
			Return -1
		End If
		
		in = in + Sgn(ch - in) * speed * dt
		
		If Abs(ch - in) <= speed Then
			in = ch
			Return -1
		End If
	End Method
	
	Method SetBGColor(Typ# = 0,r#=255,g#=255,b#=255)
		Select Typ
			Case -1
				BGNeedR = r
				BGNeedG = g
				BGNeedB = b
				BackGroundColorMode = -1
			Case 0
				BGNeedR = 0
				BGNeedG = 155
				BGNeedB = 208
				BackGroundColorMode = 0
			Case 1
				BGNeedR = 49
				BGNeedG = 127
				BGNeedB = 224
				BackGroundColorMode = 1
			Case 2
				BGNeedR = 255
				BGNeedG = 204
				BGNeedB = 102
				BackGroundColorMode = 2
			Default
				BGNeedR = 0
				BGNeedG = 155
				BGNeedB = 208
				BackGroundColorMode = 0
		End Select
	End Method
	
	Method Serealize()
		SerInt(BackGroundColorMode)
		SerFloat(BGNeedR)
		SerFloat(BGNeedG)
		SerFloat(BGNeedB)
		SerFloat(BGR)
		SerFloat(BGG)
		SerFloat(BGB)
	End Method

	Method Draw()
		If EnableForciblyPosition = 0 Then
			If EffectEnable = 0 Then
				MapPosX = Camera.camera_x
				MapPosY = Camera.camera_y
			Else
				If EffectEnable = 1 Then
					Local v1%,v2%
					v1 = AnimateValueTileMap(MapPosX,Camera.camera_x,Abs(MapPosX - Camera.camera_x)/8.0)
					v2 = AnimateValueTileMap(MapPosY,Camera.camera_y,Abs(MapPosY - Camera.camera_y)/8.0)
					AnimTimer :-1
					If v1 = -1 Or v2 = -1 Or AnimTimer < 0 Then
						EffectEnable = 0
					End If
				End If
			End If
		Else
			AnimateValueTileMap(MapPosX,PositionX,Abs(MapPosX - PositionX)/15.0)
			AnimateValueTileMap(MapPosY,PositionY,Abs(MapPosY - PositionY)/15.0)
		End If
		
		MapPosX :* Camera.Zoom
		MapPosY :* Camera.Zoom
		
		Local csp# = 5.0
		AnimateValueTileMap(BGR,BGNeedR,csp)
		AnimateValueTileMap(BGG,BGNeedG,csp)
		AnimateValueTileMap(BGB,BGNeedB,csp)
		
		SetBlend ALPHABLEND
		'SetAlpha 1
		'SetScale Camera.Zoom * 0.25,Camera.Zoom * 0.25
		'SetRotation 0
		'SetColor BGR,BGG,BGB
		'TileImage TileMapImage.Image(),-MapPosX,-MapPosY
		
		SetClsColor BGR,BGG,BGB
		Cls
		
		' hm... paralax effect :)))
		'SetScale 0.5,0.5
		SetScale Camera.Zoom*2,Camera.Zoom*2
		SetAlpha 0.3
		SetColor 255,255,255
		SetRotation 180
		If WallMap2 <> Null Then
		jTileImage WallMap2.Image(),-MapPosX/1.5 + 1024,-MapPosY/1.5 + 1024
		End If

		'SetScale 1,1
		SetScale Camera.Zoom*2,Camera.Zoom*2
		SetAlpha 0.5
		SetColor 255,255,255
		SetRotation 0
		If WallMap1 <> Null Then
		jTileImage WallMap1.Image(),-MapPosX,-MapPosY
		End If
		
		If DrawLines = 1 Then
			SetScale Camera.Zoom,Camera.Zoom
			SetAlpha 0.3
			SetColor 255,255,255
			SetRotation 0
			SetBlend ALPHABLEND
			jTileImage Edit_Map.Image(),-MapPosX + 64,-MapPosY + 64
		End If

		SetBlend ALPHABLEND
		SetAlpha 0.2
		SetScale 1,1
		SetRotation 0
		SetColor 255,255,255

		Local out% = 0
		For Local cr:TCreation = EachIn Creations
			If cr.GlowEnable = 1 And Camera.ImageInViewPort(TileMapFx.Image(),cr.gco(0).x,cr.gco(0).y) Then
				out :+1
				TileMapFx.DrawResource(cr.gco(0).x,cr.gco(0).y)
			End If
			
			If out > DrawableMax Then Exit
		Next
	End Method
	
	Method SetEnableForciblyPosition(flag%)
		If EnableForciblyPosition <> flag Then
			EnableForciblyPosition = flag
			EffectEnable = 1
			AnimTimer = 20
		End If
	End Method
	
	Function CreateTileMap()
		TileMap = New TTileMap
		TileMap.SetBGColor()
		TileMap.BGR = TileMap.BGNeedR
		TileMap.BGG = TileMap.BGNeedG
		TileMap.BGB = TileMap.BGNeedB
		TileMap.TileMapImage = GetResImage("TileMap_Main")
		TileMap.TileMapFx = GetResImage("Fx_TileMap")
		TileMap.WallMap1 = GetResImage("Fx_WallMap1")
		TileMap.WallMap2 = GetResImage("Fx_WallMap2")
		TileMap.WallMap3 = GetResImage("Fx_WallMap3")
		TileMap.WallMap4 = GetResImage("Fx_WallMap4")
		
		TileMap.Edit_Map = GetResImage("Edit_Map")
		
		TileMap.DrawLines = EditorMode
	End Function

End Type